;====================================================================
; Project:		GUIw512 Form Editor
; Version:		0.11 Beta
; GUI Version:	1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	   GUIw512
;                   
;====================================================================
Const FEdVersion$="0.11 Beta"

Graphics3D 800,600,32,2
AppTitle "GUIw512 Form Editor v."+FEdVersion

;	----------===  GUI ===----------
Include "..\B3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\B3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

SetFont LoadFont ("Tahoma",16)

WG_SetDragnDropKey(29)
WG_SetFileReqStart(CurrentDir())
WGV_WindowCloseType=1

;	----------===  GUI ===----------
Global MainMenu%, ToolBar%, PropWin%, GroupWin%
Global Pointer%, PointerInput%, PointerHelp%, PointerRect%
Local mnFile%,mnSave%,mnOpen%,mnExit%,mnElems%,mnGroups%,mnExport%,mnImport%
Local btWindow%,btButton%,btTbButton%,btCheckBox%,btOptionBt%
Local btLabel%,btImage%,btTextBox%,btTextArea%,btListBox%,btComboBox%
Local btScrollBar%,btFrame%,btDivider%
Global gpList%,gpGpName%,gpAdd%,gpDel%,gpOk%,gpCencel%
Global tbName%,tbX%,tbY%,tbWidth%,tbHeight%,tbLabel%,tbTextAlign%,tbHelp%,tbCopy%
Global tbVisible%,tbAlpha%,tbGroup%,tbLock%,tbDnD%,tbDel%,PropType%,PropBasic%,PropSpec%

Const GpWinH1%=164,GpWinH2%=205

;	----------===   ===----------
Global ZoneX%,ZoneY%,ZoneW%,ZoneH%,PropX%,PropY%,PropW%,PropH%,Parent%
Local E.TElem,Q.TElem, error%, hiden%, hndl%

;	----------===    ===----------
Type TElem
	Field id%
	Field name$
	
	Field hidden%
	Field moveble%
	Field ItemGroup%
	Field ItemProp%
	Field groupName$
End Type

Global Prop.TElem

;	----------===  ===----------
Pointer=WG_CreatePointer(LoadImageEx("..\media\pointer.png",2,0))
PointerInput=WG_CreatePointer(LoadImageEx("..\media\pointer_input.png",2,0),3,8)
PointerHelp=WG_CreatePointer(LoadImageEx("..\media\pointer_help.png",2,0))
PointerRect=WG_CreatePointer(LoadImageEx("..\media\pointer_rect.png",2,0))

WG_SetPointer(Pointer)
WG_SetPointerInput(PointerInput)
WG_SetPointerHelp(PointerHelp)

HidePointer()

;	----------===   ===----------
MainMenu=WG_CreateMenu(1,1," ")
ToolBar=WG_CreateToolBar(1,1," ")
PropWin=WG_CreateWindow(100,100,200,335,"",0,0,1,0)
GroupWin=WG_CreateWindow(150,150,180,GpWinH1,"",0,0,1,1)

WG_HideElement(GroupWin)

;	----------===   ===----------
mnFile=WG_AddMenuItem(MainMenu,"")
mnSave=WG_AddMenuItem(MainMenu,"\")
mnOpen=WG_AddMenuItem(MainMenu,"\")
mnExport=WG_AddMenuItem(MainMenu,"\")
mnImport=WG_AddMenuItem(MainMenu,"\")
mnExit=WG_AddMenuItem(MainMenu,"\")

mnElems=WG_AddMenuItem(MainMenu,"")
mnGroups=WG_AddMenuItem(MainMenu,"\")

;WG_LockElement(mnSave)
;WG_LockElement(mnOpen)
WG_LockElement(mnImport)

;	----------===    ===----------
btWindow=WG_CreateButton(ToolBar,0,0,0,0,"",0,0,0,1)
btButton=WG_CreateButton(ToolBar,0,0,0,0,"",0,0,0,1)
btTbButton=WG_CreateButton(ToolBar,0,0,0,0,"",0,0,0,1)
btCheckBox=WG_CreateButton(ToolBar,0,0,0,0,"CheckBox",0,0,0,1)
btOptionBt=WG_CreateButton(ToolBar,0,0,0,0,"OptionBt",0,0,0,1)
btLabel=WG_CreateButton(ToolBar,0,0,0,0,"Label",0,0,0,1)
btImage=WG_CreateButton(ToolBar,0,0,0,0,"Image",0,0,0,1)
btTextBox=WG_CreateButton(ToolBar,0,0,0,0,"TextBox",0,0,0,1)
btTextArea=WG_CreateButton(ToolBar,0,0,0,0,"TextArea",0,0,0,1)
btListBox=WG_CreateButton(ToolBar,0,0,0,0,"ListBox",0,0,0,1)
btComboBox=WG_CreateButton(ToolBar,0,0,0,0,"ComboBox",0,0,0,1)
btScrollBar=WG_CreateButton(ToolBar,0,0,0,0,"ScrollBar",0,0,0,1)
btFrame=WG_CreateButton(ToolBar,0,0,0,0,"Frame",0,0,0,1)
btDivider=WG_CreateButton(ToolBar,0,0,0,0,"Divider",0,0,0,1)

;	----------===   "" ===----------
Local shiftY%=25
PropType=WG_CreateGroup()
PropBasic=WG_CreateOptionButton(PropWin,PropType,10,10,70,20,"",1)
PropSpec=WG_CreateOptionButton(PropWin,PropType,90,10,100,20,"")
tbName=WG_CreateTextBox(PropWin,100,shiftY+10,90,"",100,4," :")
tbX=WG_CreateTextBox(PropWin,100,shiftY+30,90,"",100,3,"x:")
tbY=WG_CreateTextBox(PropWin,100,shiftY+50,90,"",100,3,"y:")
tbWidth=WG_CreateTextBox(PropWin,100,shiftY+70,90,"",100,3,":")
tbHeight=WG_CreateTextBox(PropWin,100,shiftY+90,90,"",100,3,":")
tbLabel=WG_CreateTextBox(PropWin,100,shiftY+110,90,"",100,0,":")
tbTextAlign=WG_CreateTextBox(PropWin,100,shiftY+130,90,"",100,3,". :")
tbHelp=WG_CreateTextBox(PropWin,100,shiftY+150,90,"",100,0,":")
tbAlpha=WG_CreateTextBox(PropWin,100,shiftY+170,90,"",100,2,":",1,.01,0,1)
tbGroup=WG_CreateComboBox(PropWin,60,shiftY+190,130,4,"","",":")
tbVisible=WG_CreateCheckBox(PropWin,10,shiftY+215,90,15,"")
tbLock=WG_CreateCheckBox(PropWin,100,shiftY+215,90,15,"")
tbDnD=WG_CreateCheckBox(PropWin,10,shiftY+235,110,15,"")
tbCopy=WG_CreateButton(PropWin,10,shiftY+260,180,20,"")
tbDel=WG_CreateButton(PropWin,10,shiftY+285,180,20,"")

WG_LockElement(PropSpec)

;Field desc.TDescription
;Field ico.TIcon
;Field group%
;Field groupNum%
;Field context%
;Field pointer%

;	----------===   "" ===----------
gpList=WG_CreateListBox(GroupWin,10,10,160,6)
gpAdd=WG_CreateButton(GroupWin,10,135,75,20,"")
gpDel=WG_CreateButton(GroupWin,95,135,75,20,"")
gpOk=WG_CreateButton(GroupWin,10,175,75,20,"")
gpCencel=WG_CreateButton(GroupWin,95,175,75,20,"")
WG_CreateDivider(GroupWin,30,165,120,0)

;	----------===  3  ===----------
CreateWorld()

;	----------===   ===----------
Repeat
	
;	----------=== RenderWorld ===----------
	RenderWorld
	
;	----------=== UpDate GUI ===----------
	StartDraw()
	
	GUIw512_UpDate()
	
	If Prop<>Null Then
		SetBlend(FI_ALPHABLEND)
		SetAlpha(.1)
		SetColor(200,50,10)
		DrawRectSimple(PropX,PropY,PropW,PropH,1)
	EndIf
	
	EndDraw()
	
	If KeyHit(1)<>0 Then If WG_MessageBox(""," ?","\",7,1)=1 Then Exit
	
;	----------===   ===----------
	Select WG_GetEvent()
	;	==============================================
	;	----------===    ===----------
		Case WGV_EventMenuSelect
			Select WG_EventSource()
				Case mnGroups
					WG_ShowElement(GroupWin)
					WG_ActivateWindowE(GroupWin)
				Case mnOpen
					If WG_RequestFileName(200,100,0,"GUI Layout (*.glo)")<>"" Then
						LoadLayout(WG_RequesterAdress()+WG_RequesterFileName())
					EndIf
				Case mnSave
					If WG_RequestFileName(200,100,1,"GUI Layout (*.glo)")<>"" Then
						SaveLayout(WG_RequesterAdress()+WG_RequesterFileName())
					EndIf
				Case mnExport
					If WG_RequestFileName(200,100,1,"BlitzBasic (*.bb)")<>"" Then
						ExportLayout(WG_RequesterAdress()+WG_RequesterFileName())
					EndIf
				Case mnExit
					If WG_MessageBox(""," ?","\",7,1)=1 Then Exit
			End Select
	;	==============================================
	;	----------===    ===----------
		Case WGV_EventElementClick
			Select WG_EventSource()
		;	----------===   ===----------
				Case btWindow
					If GetZone()=1 Then CreateElement(WGWindow)
		;	----------===   ===----------
				Case btButton
					If GetParentZone()=1 Then CreateElement(WGButton)
		;	----------===  - ===----------
				Case btTbButton
					If GetParentZone()=1 Then CreateElement(WGToggleButton)
		;	----------===  checkbox'a ===----------
				Case btCheckBox
					If GetParentZone()=1 Then CreateElement(WGCheckBox)
		;	----------===  OptionBt'a ===----------
				Case btOptionBt
					If GetParentZone()=1 Then
						hiden=WG_ElementVisible(GroupWin)
						
						WG_SetElementHeight(GroupWin,GpWinH2)
						WG_ShowElement(GroupWin)
						WG_LockWindow(GroupWin)
					EndIf
		;	----------===  Label'a ===----------
				Case btLabel
					If GetParentZone()=1 Then CreateElement(WGLabel)
		;	----------===  Image'a ===----------
				Case btImage
					If GetParentZone()=1 Then
						If WG_RequestFileName(100,100,0,"*.jpg; *.bmp; *.png; *.tga")<>"" Then
							Prop.TElem=New TElem
							Prop\name="Img_"+Handle(Prop.TElem)
							Prop\id=WG_CreateImage(Parent,ZoneX,ZoneY,LoadTexture(WG_RequesterAdress()+WG_RequesterFileName(),2))
							
							WG_SetElementDragnDrop(Prop\id,1)
							
							GetProp(Prop)
						EndIf
					EndIf
		;	----------===  TextBox'a ===----------
				Case btTextBox
					If GetParentZone()=1 Then CreateElement(WGTextBox)
		;	----------===  TextArea'a ===----------
				Case btTextArea
					If GetParentZone()=1 Then CreateElement(WGTextArea)
		;	----------===  ListBox'a ===----------
				Case btListBox
					If GetParentZone()=1 Then CreateElement(WGListBox)
		;	----------===  ComboBox'a ===----------
				Case btComboBox
					If GetParentZone()=1 Then CreateElement(WGComboBox)
		;	----------===  ScrollBar'a ===----------
				Case btScrollBar
					If GetParentZone()=1 Then CreateElement(WGScrollBar)
		;	----------===  Frame'a ===----------
				Case btFrame
					If GetParentZone()=1 Then CreateElement(WGFrame)
		;	----------===  Divider'a ===----------
				Case btDivider
					If GetParentZone()=1 Then CreateElement(WGDivider)
		;	----------===   ===----------
				Case gpAdd
					CreateElement(WGGroup)
		;	----------===   ===----------
				Case gpDel
					hndl=WG_BoxSelectHandle(gpList)
					If hndl<>0 Then
						For E.TElem=Each TElem
							If E\ItemGroup=hndl And WG_ElementType(E\id)=WGGroup Then
								If WG_MessageBox("","     ?","\",7,1)=2 Then
									error=0
									For Q.TElem=Each TElem
										If WG_ElementGroup(Q\id)=E\id And WG_ElementType(Q\id)=WGOptionButton Then
											error=1
											WG_MessageBox("","    , ..     OptionButton,      ")
											Exit
										EndIf
									Next
									If error=1 Then Exit
									For Q.TElem=Each TElem
										If WG_ElementGroup(Q\id)=E\id Then
											Q\groupName=""
											WG_SetElementGroup(Q\id,0)
										EndIf
									Next
								Else
									For Q.TElem=Each TElem
										If WG_ElementGroup(Q\id)=E\id Then
											WG_FreeElement(Q\id)
											Delete Q
										EndIf
									Next
								EndIf
								WG_FreeElement(E\id)
								WG_FreeElement(E\ItemGroup)
								WG_FreeElement(E\ItemProp)
								Delete E
								GetProp(Null)
								Exit
							EndIf
						Next
					EndIf
		;	----------===  OptBt ===----------
				Case gpOk
					hndl=WG_BoxSelectHandle(gpList)
					If hndl=0 Then
						WG_MessageBox(""," ,    OptionButton")
					Else
						For E.TElem=Each TElem
							If E\ItemGroup=hndl And WG_ElementType(E\id)=WGGroup Then Exit
						Next
						
						Prop.TElem=New TElem
						Prop\name="Opt_"+Handle(Prop.TElem)
						Prop\id=WG_CreateOptionButton(Parent,E\id,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
						Prop\groupName=E\name
						
						WG_SetElementDragnDrop(Prop\id,1)
						
						GetProp(Prop)
						
						If hiden=0 Then WG_HideElement(GroupWin)
						WG_SetElementHeight(GroupWin,GpWinH1)
						WG_LockWindow(0)
					EndIf
		;	----------===   OptBt ===----------
				Case gpCencel
					If hiden=0 Then WG_HideElement(GroupWin)
					WG_SetElementHeight(GroupWin,GpWinH1)
					WG_LockWindow(0)
		;	----------===  -: / ===----------
				Case tbVisible
					Prop\hidden=WGV_EventState
					
					If WG_ElementType(Prop\id)=WGGroup Then
						For E.TElem=Each TElem
							If WG_ElementGroup(E\id)=Prop\id Then E\hidden=WGV_EventState
						Next
					EndIf
		;	----------===  -: ? ===----------
				Case tbLock
					WG_LockElement(Prop\id,WGV_EventState)
		;	----------===  -:  ===----------
				Case tbDnD
					Prop\moveble=WGV_EventState
					
					If WG_ElementType(Prop\id)=WGGroup Then
						For E.TElem=Each TElem
							If WG_ElementGroup(E\id)=Prop\id Then E\moveble=WGV_EventState
						Next
					EndIf
		;	----------===   ===----------
				Case tbDel
					If Prop<>Null Then
						If WG_ElementType(Prop\id)=WGWindow Then
							For E.TElem=Each TElem
								If WG_ElementParent(E\id)=Prop\id Then Delete E
							Next
						EndIf
						WG_FreeElement(Prop\id)
						Delete Prop
						GetProp(Null)
					EndIf
		;	----------===   ===----------
				Case tbCopy
					If Prop<>Null Then
						E=Prop
						Parent=WG_ElementParent(Prop\id)
						ZoneX=WG_ElementX(Prop\id)+10
						ZoneY=WG_ElementY(Prop\id)+10
						ZoneW=WG_ElementWidth(Prop\id)
						ZoneH=WG_ElementHeight(Prop\id)
						
						If WG_ElementType(Prop\id)=WGWindow Then
							ZoneW=ZoneW+(WGV_WindowBorderWidth Shl 1)
							ZoneH=ZoneH+WGV_HeaderHeightW+WGV_WindowBorderWidth
						EndIf
						
						CreateElement(WG_ElementType(Prop\id))
						
						WG_SetElementLabel(Prop\id, WG_ElementLabel(E\id))
						WG_SetElementTextAlign(Prop\id, WG_ElementTextAlign(E\id))
						WG_SetElementHelp(Prop\id, WG_ElementHelp(E\id))
						WG_SetElementAlpha(Prop\id, WG_ElementAlpha(E\id))
						WG_SetElementGroup(Prop\id, WG_ElementGroup(E\id))
						WG_LockElement(Prop\id, WG_ElementLockState(E\id))
						WG_SetElementLabel(Prop\id, WG_ElementLabel(E\id))
						Prop\hidden=E\hidden
						Prop\moveble=E\moveble
						Prop\groupName=E\groupName
						
						GetProp(Prop)
					EndIf
		;	----------===     ===----------
				Default
					For E.TElem=Each TElem
						If WGV_EventSource=E\id Then
							If Prop<>E Then GetProp(E)
							Exit
						EndIf
					Next
			End Select
	;	==============================================
	;	----------===   ===----------
		Case WGV_EventElementDown
			Select WG_EventSource()
				Default
					For E.TElem=Each TElem
						If WGV_EventSource=E\id Then
							If Prop<>E Then GetProp(E)
							Exit
						EndIf
					Next
			End Select
	;	==============================================
	;	----------===   OptBt ===----------
		Case WGV_EventOptionButtonSelect
			Select WG_EventSource()
				Default
					For E.TElem=Each TElem
						If WGV_EventSource=E\id Then
							If Prop<>E Then GetProp(E)
							Exit
						EndIf
					Next
			End Select
	;	==============================================
	;	----------===    ===----------
		Case WGV_EventBoxSelect
			Select WG_EventSource()
				Case tbGroup
					If Prop<>Null Then
						If WG_EventLabel()="" Then
							If WG_ElementType(Prop\id)=WGOptionButton Then
								WG_MessageBox(""," OptionButton     ","Ok",7,1)
							Else
								Prop\groupName=""
								WG_SetElementGroup(Prop\id,0)
							EndIf
						Else
							For E.TElem=Each TElem
								If E\name=WGV_EventLabel And WG_ElementType(E\id)=WGGroup Then
									Prop\groupName=WGV_EventLabel
									WG_SetElementGroup(Prop\id,E\id)
									Exit
								EndIf
							Next
						EndIf
					EndIf
				Case gpList
					For E.TElem=Each TElem
						If E\ItemGroup=WGV_EventData And WG_ElementType(E\id)=WGGroup Then
							GetProp(E)
							Exit
						EndIf
					Next
			End Select
	;	==============================================
	;	----------===   ===----------
		Case WGV_EventElementMoving
			If WGV_EventSource=Prop\id Then
				PropX=WG_ElementX(Prop\id,True)
				PropY=WG_ElementY(Prop\id,True)
				WG_SetElementLabel(tbX, WG_ElementX(Prop\id,False))
				WG_SetElementLabel(tbY, WG_ElementY(Prop\id,False))
			Else
				For E.TElem=Each TElem
					If WGV_EventSource=E\id Then
						GetProp(E)
						Exit
					EndIf
				Next
			EndIf
	;	================================================
	;	----------===   ===----------
		Case WGV_EventTextBoxInput
			If Prop<>Null Then
				Select WG_EventSource()
				;	----------===   ===----------
					Case tbName
						error=0
						For E.TElem=Each TElem
							If WGV_EventLabel=E\name Then
								If Prop<>E Then
									WG_MessageBox("","     ")
									WG_SetElementLabel(tbName,Prop\name)
									error=1
									Exit
								EndIf
							EndIf
						Next
						If error=0 Then
							Prop\name=WGV_EventLabel
							If WG_ElementType(Prop\id)=WGGroup Then
								WG_SetElementLabel(Prop\ItemGroup,WGV_EventLabel)
							EndIf
						EndIf
				;	----------===   ===----------
					Case tbX
						If WG_ElementType(Prop\id)=WGGroup Then
							WG_MoveElement(Prop\id,Int(WGV_EventLabel)-WG_ElementX(Prop\id),0)
						Else
							PropX=PropX+Int(WGV_EventLabel)-WG_ElementX(Prop\id)
							WG_SetElementX(Prop\id,Int(WGV_EventLabel))
						EndIf
				;	----------===  Y ===----------
					Case tbY
						If WG_ElementType(Prop\id)=WGGroup Then
							WG_MoveElement(Prop\id,0,Int(WGV_EventLabel)-WG_ElementY(Prop\id))
						Else
							PropY=PropY+Int(WGV_EventLabel)-WG_ElementY(Prop\id)
							WG_SetElementY(Prop\id,Int(WGV_EventLabel))
						EndIf
				;	----------===  ===----------
					Case tbWidth
						PropW=PropW+Int(WGV_EventLabel)-WG_ElementWidth(Prop\id)
						WG_SetElementWidth(Prop\id,Int(WGV_EventLabel))
				;	----------===  ===----------
					Case tbHeight
						PropH=PropH+Int(WGV_EventLabel)-WG_ElementHeight(Prop\id)
						WG_SetElementHeight(Prop\id,Int(WGV_EventLabel))
				;	----------===  ===----------
					Case tbLabel
						WG_SetElementLabel(Prop\id,WGV_EventLabel)
				;	----------===   ===----------
					Case tbTextAlign
						WG_SetElementTextAlign(Prop\id,Int(WGV_EventLabel))
				;	----------===  ===----------
					Case tbHelp
						WG_SetElementHelp(Prop\id,WGV_EventLabel)
				;	----------===  ===----------
					Case tbAlpha
						WG_SetElementAlpha(Prop\id,Float(WGV_EventLabel))
				End Select
			EndIf
	;	====================================================
	;	----------===    ===----------
		Case WGV_EventWindowChangeState
			Select WG_EventSource()
			;	----------===     ===----------
				Case GroupWin
					If WG_EventState()=WGV_WindowHide Then
						If WG_ElementHeight(GroupWin)=GpWinH2 Then
							WG_SetElementHeight(GroupWin,GpWinH1)
							WG_LockWindow(0)
						EndIf
					EndIf
			;	----------===    ===----------
				Default
					For E.TElem=Each TElem
						If WGV_EventSource=E\id Then
							If E<>Prop Then GetProp(E)
					;	----------===   ===----------
							Select WG_EventState()
								Case WGV_StateMoving,WGV_StateMoveEnd
									PropX=PropX+WG_EventX()-Int(WG_ElementLabel(tbX))
									PropY=PropY+WG_EventY()-Int(WG_ElementLabel(tbY))
									WG_SetElementLabel(tbX,WG_EventX())
									WG_SetElementLabel(tbY,WG_EventY())
								Case WGV_WindowClose,WGV_WindowHide
									WG_SetWindowState(WGV_EventSource,WGV_WindowMaximize)
									WG_ShowElement(WGV_EventSource)
							End Select
							Exit
						EndIf
					Next
			End Select
	End Select
	
;	----------===  FPS ===----------
	Color 100,110,120
	Text GraphicsWidth() Shr 1,5,WGV_FPS,1
	
	Flip 0
Forever

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=CreateLight()
	RotateEntity light,45,-60,0
	cam=CreateCamera()
	CameraClsColor cam,10,20,30
	cub=CreateCube()
	RotateEntity cub,-10,-20,-10
	tex=LoadTexture("..\media\LogoTex.png")
	EntityTexture cub,tex
	PositionEntity cub,-3,-1.7,6
End Function

Function CreateElement(eType%)
	Select eType
		Case WGWindow
			If ZoneW<50 Then ZoneW=50
			If ZoneH<WGV_HeaderHeightW+WGV_WindowBorderWidth+5 Then ZoneH=WGV_HeaderHeightW+WGV_WindowBorderWidth+5
			Prop.TElem=New TElem
			Prop\name="Win_"+Handle(Prop.TElem)
			Prop\id=WG_CreateWindow(ZoneX,ZoneY,ZoneW-(WGV_WindowBorderWidth Shl 1),ZoneH-WGV_HeaderHeightW-WGV_WindowBorderWidth,Prop\name)
			Prop\moveble=1
			
		Case WGButton
			Prop.TElem=New TElem
			Prop\name="Btn_"+Handle(Prop.TElem)
			Prop\id=WG_CreateButton(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGToggleButton
			Prop.TElem=New TElem
			Prop\name="TBt_"+Handle(Prop.TElem)
			Prop\id=WG_CreateToggleButton(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGCheckBox
			Prop.TElem=New TElem
			Prop\name="ChBx_"+Handle(Prop.TElem)
			Prop\id=WG_CreateCheckBox(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGLabel
			Prop.TElem=New TElem
			Prop\name="Lbl_"+Handle(Prop.TElem)
			Prop\id=WG_CreateLabel(Parent,ZoneX,ZoneY,Prop\name,ZoneW,ZoneH)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGTextBox
			Prop.TElem=New TElem
			Prop\name="TBx_"+Handle(Prop.TElem)
			Prop\id=WG_CreateTextBox(Parent,ZoneX,ZoneY,ZoneW,Prop\name,100)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGTextArea
			GetFontProperty(WGV_Font)
			Prop.TElem=New TElem
			Prop\name="TAr_"+Handle(Prop.TElem)
			Prop\id=WG_CreateTextArea(Parent,ZoneX,ZoneY,ZoneW,ZoneH/FI_FontProperty\Height,Prop\name)
			WG_SetElementDragnDrop(Prop\id,1)
				
		Case WGListBox
			GetFontProperty(WGV_Font)
			Prop.TElem=New TElem
			Prop\name="LBx_"+Handle(Prop.TElem)
			Prop\id=WG_CreateListBox(Parent,ZoneX,ZoneY,ZoneW,ZoneH/FI_FontProperty\Height)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGComboBox
			Prop.TElem=New TElem
			Prop\name="CBx_"+Handle(Prop.TElem)
			Prop\id=WG_CreateComboBox(Parent,ZoneX,ZoneY,ZoneW,4,Prop\name)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGScrollBar
			Prop.TElem=New TElem
			Prop\name="ScBr_"+Handle(Prop.TElem)
			If ZoneW>ZoneH Then
				Prop\id=WG_CreateScrollBar(Parent,ZoneX,ZoneY,ZoneW,10,0)
			Else
				Prop\id=WG_CreateScrollBar(Parent,ZoneX,ZoneY,ZoneH,10,1)
			EndIf
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGFrame
			Prop.TElem=New TElem
			Prop\name="Frm_"+Handle(Prop.TElem)
			Prop\id=WG_CreateFrame(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGDivider
			Prop.TElem=New TElem
			Prop\name="Div_"+Handle(Prop.TElem)
			If ZoneW>ZoneH Then
				Prop\id=WG_CreateDivider(Parent,ZoneX,ZoneY,ZoneW,0,Prop\name)
			Else
				Prop\id=WG_CreateDivider(Parent,ZoneX,ZoneY,ZoneH,1,Prop\name)
			EndIf
			WG_SetElementDragnDrop(Prop\id,1)
			
		Case WGGroup
			Prop.TElem=New TElem
			Prop\name="Grp_"+Handle(Prop.TElem)
			Prop\id=WG_CreateGroup()
			Prop\ItemGroup=WG_AddBoxItem(gpList,Prop\name)
			Prop\ItemProp=WG_AddBoxItem(tbGroup,Prop\name)
			
		Default
			Return
	End Select
	
	GetProp(Prop)
End Function

Function GetZone(x1%=0, y1%=0, x2%=0, y2%=0)
	Local start%=0, x%, y%, width%, height%, limit%, tmpx%, tmpy%
	
	If x1<>x2 And y1<>y2 Then limit=1
	
	ZoneX=0
	ZoneY=0
	ZoneW=0
	ZoneH=0
	
	WGV_LockMExtern=1
	WGV_LockMouse=-10
	FlushMouse
	
	WG_SetPointer(PointerRect)
	
	While KeyHit(1)=0
		RenderWorld
		StartDraw()
		
		GUIw512_UpDate()
		
		If limit=1 Then
			tmpx=MouseX() : tmpy=MouseY()
			If tmpx<x1 Then tmpx=x1
			If tmpy<y1 Then tmpy=y1
			If tmpx>x2 Then tmpx=x2
			If tmpy>y2 Then tmpy=y2
			MoveMouse tmpx,tmpy
		EndIf
		
		If MouseDown(1)=1 Then
			If start=0 Then
				ZoneX=MouseX()
				ZoneY=MouseY()
				start=1
			Else
				If ZoneX<MouseX() Then
					x=ZoneX
					width=MouseX()-ZoneX
				Else
					x=MouseX()
					width=ZoneX-MouseX()
				EndIf
				If ZoneY<MouseY() Then
					y=ZoneY
					height=MouseY()-ZoneY
				Else
					y=MouseY()
					height=ZoneY-MouseY()
				EndIf
				
				SetAlpha(1)
				SetColor(255,255,255)
				DrawRectSimple(x,y,width,height,0)
			EndIf
		Else
			If start<>0 Then
				ZoneX=x-x1
				ZoneY=y-y1
				ZoneW=width
				ZoneH=height
				Exit
			EndIf
		EndIf
		
		EndDraw()
		Flip 0
	Wend
	
	WG_SetPointer(Pointer)
	WGV_LockMExtern=0
	
	If ZoneW=0 Or ZoneH=0 Then Return 0 Else Return 1
End Function

Function GetParentZone%()
	Local E.TElem, x1%, y1%, x2%, y2%, pt%
	
	WGV_LockMExtern=1
	WGV_LockMouse=-10
	FlushMouse
	
	WG_SetPointer(PointerRect)
	
	While KeyHit(1)=0
		RenderWorld
		
		StartDraw()
		GUIw512_UpDate()
		EndDraw()
		
		If MouseHit(1)=True Then
			pt=WG_GetActiveParent()
			If pt<>0 Then
				For E.TElem=Each TElem
					If pt=E\id Then
						Select WG_ElementType(E\id)
							Case WGWindow
								WGV_LockMExtern=0
								
								Parent=E\id
								WG_ActivateWindowE(E\id)
								x1=WG_ElementX(E\id)+WGV_WindowBorderWidth
								y1=WG_ElementY(E\id)+WGV_HeaderHeightW
								x2=x1+WG_ElementWidth(E\id)
								y2=y1+WG_ElementHeight(E\id)
								
								Return GetZone(x1,y1,x2,y2)
						End Select
					EndIf
				Next
			EndIf
		EndIf
		
		Flip 0
	Wend
	
	WG_SetPointer(Pointer)
	WGV_LockMExtern=0
	Return 0
End Function

Function GetProp(E.TElem)
	If E=Null Then
		Prop=Null
		PropX=0
		PropY=0
		PropW=0
		PropH=0
		
		WG_SetElementLabel(tbName, "")
		WG_SetElementLabel(tbX, 0)
		WG_SetElementLabel(tbY, 0)
		WG_SetElementLabel(tbWidth, 0)
		WG_SetElementLabel(tbHeight, 0)
		WG_SetElementLabel(tbLabel, "")
		WG_SetElementLabel(tbTextAlign, 0)
		WG_SetElementLabel(tbHelp, "")
		WG_SetElementLabel(tbAlpha, 0)
		
		WG_SetElementToggle(tbVisible, 0)
		WG_SetElementToggle(tbLock, 0)
		WG_SetElementToggle(tbDnD, 0)
		
		Return
	EndIf
	
	GUIw512_UpDate()
	
	Prop=E
	PropX=WG_ElementX(Prop\id,True)
	PropY=WG_ElementY(Prop\id,True)
	PropW=WG_ElementWidth(Prop\id)
	PropH=WG_ElementHeight(Prop\id)
	
	WG_SetElementLabel(tbName, Prop\name)
	WG_SetElementLabel(tbX, WG_ElementX(Prop\id,False))
	WG_SetElementLabel(tbY, WG_ElementY(Prop\id,False))
	WG_SetElementLabel(tbWidth, PropW)
	WG_SetElementLabel(tbHeight, PropH)
	WG_SetElementLabel(tbLabel, WG_ElementLabel(Prop\id))
	WG_SetElementLabel(tbTextAlign, WG_ElementTextAlign(Prop\id))
	WG_SetElementLabel(tbHelp, WG_ElementHelp(Prop\id))
	WG_SetElementLabel(tbAlpha, WG_ElementAlpha(Prop\id))
	
	If Prop\groupName="" Then
		WG_SetBoxSelectLabel(tbGroup,"")
	Else
		WG_SetBoxSelectLabel(tbGroup,Prop\groupName)
	EndIf
	
	WG_SetElementToggle(tbVisible, Prop\hidden)
	WG_SetElementToggle(tbLock, WG_ElementLockState(Prop\id))
	WG_SetElementToggle(tbDnD, Prop\moveble)
	
	Select WG_ElementType(Prop\id)
		Case WGWindow
			PropW=PropW+(WGV_WindowBorderWidth Shl 1)
			PropH=PropH+WGV_WindowBorderWidth+WGV_HeaderHeightW
	End Select
End Function

Function FindElement(name$, Etype%)
	Local Q.TElem
	
	For Q.TElem = Each TElem
		If WG_ElementType(Q\id) = Etype Then
			If Q\name = name Then Return Q\id
		EndIf
	Next
	
	Return 0
End Function

Function ExportLayout(filename$)
	Local E.TElem, Q.TElem, file%=WriteFile(filename)
	
	WriteLine file,"; Layout created with GUIw512 Form Editor v."+FEdVersion
	WriteLine file,"; http://www.siberiansun.ru"
	WriteLine file,""
	WriteLine file,";####################  ####################"
	WriteLine file,""
	
	For E.TElem=Each TElem
		If WG_ElementType(E\id)=WGGroup Then
			ExportElem(E,file)
		EndIf
	Next
	
	WriteLine file,""
	WriteLine file,";####################  ####################"
	WriteLine file,""
	
	For E.TElem=Each TElem
		If WG_ElementType(E\id)=WGWindow Then
			ExportElem(E,file)
			
			For Q.TElem=Each TElem
				If WG_ElementParent(Q\id)=E\id Then
					ExportElem(Q,file,E\name)
				EndIf
			Next
		EndIf
	Next
	
	CloseFile(file)
	
	WG_MessageBox("","    : "+filename,"Ok",7,1)
End Function

Function SaveLayout(filename$)
	Local E.TElem, Q.TElem, file%=WriteFile(filename)
	
	;####################  ####################
	
	For E.TElem=Each TElem
		If WG_ElementType(E\id)=WGGroup Then
			SaveElem(E,file)
		EndIf
	Next
	
	;####################  ####################
	
	For E.TElem=Each TElem
		If WG_ElementType(E\id)=WGWindow Then
			SaveElem(E,file)
			
			For Q.TElem=Each TElem
				If WG_ElementParent(Q\id)=E\id Then
					SaveElem(Q,file,E\name)
				EndIf
			Next
		EndIf
	Next
	
	CloseFile(file)
	
	WG_MessageBox("","    : "+filename,"Ok",7,1)
End Function

Function LoadLayout(filename$)
	Local E.TElem, Q.TElem, file%=OpenFile(filename)
	Local vType%,vParentName$,vGroup%
	Local vLable$,vHelp$,vTextAlign%,vAlpha#,vLock%
	
	While Not Eof(file)
		Prop.TElem = New TElem
		
		vType = ReadInt(file)
		Prop\name = ReadString(file)
		Prop\groupName = ReadString(file)
		vParentName = ReadString(file)
		Prop\hidden = ReadInt(file)
		Prop\moveble = ReadInt(file)
		
		ZoneX = ReadInt(file)
		ZoneY = ReadInt(file)
		ZoneW = ReadInt(file)
		ZoneH = ReadInt(file)
		vLable = ReadString(file)
		vHelp = ReadString(file)
		vTextAlign = ReadInt(file)
		vAlpha = ReadFloat(file)
		vLock = ReadInt(file)
		
		Parent = FindElement(vParentName, WGWindow)
		vGroup = FindElement(Prop\groupName, WGGroup)
		
		Select vType
			Case WGWindow
				Prop\id=WG_CreateWindow(ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			Case WGButton
				Prop\id=WG_CreateButton(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			Case WGToggleButton
				Prop\id=WG_CreateToggleButton(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			Case WGCheckBox
				Prop\id=WG_CreateCheckBox(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			Case WGOptionButton
				Prop\id=WG_CreateOptionButton(Parent,vGroup,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			Case WGLabel
				Prop\id=WG_CreateLabel(Parent,ZoneX,ZoneY,Prop\name,ZoneW,ZoneH)
			Case WGTextBox
				Prop\id=WG_CreateTextBox(Parent,ZoneX,ZoneY,ZoneW,Prop\name,100)
			Case WGTextArea
				GetFontProperty(WGV_Font)
				Prop\id=WG_CreateTextArea(Parent,ZoneX,ZoneY,ZoneW,ZoneH/FI_FontProperty\Height,Prop\name)
			Case WGListBox
				GetFontProperty(WGV_Font)
				Prop\id=WG_CreateListBox(Parent,ZoneX,ZoneY,ZoneW,ZoneH/FI_FontProperty\Height)
			Case WGComboBox
				Prop\id=WG_CreateComboBox(Parent,ZoneX,ZoneY,ZoneW,4,Prop\name)
			Case WGScrollBar
				If ZoneW>ZoneH Then
					Prop\id=WG_CreateScrollBar(Parent,ZoneX,ZoneY,ZoneW,10,0)
				Else
					Prop\id=WG_CreateScrollBar(Parent,ZoneX,ZoneY,ZoneH,10,1)
				EndIf
			Case WGFrame
				Prop\id=WG_CreateFrame(Parent,ZoneX,ZoneY,ZoneW,ZoneH,Prop\name)
			Case WGDivider
				If ZoneW>ZoneH Then
					Prop\id=WG_CreateDivider(Parent,ZoneX,ZoneY,ZoneW,0,Prop\name)
				Else
					Prop\id=WG_CreateDivider(Parent,ZoneX,ZoneY,ZoneH,1,Prop\name)
				EndIf
			Case WGGroup
				Prop\id=WG_CreateGroup()
				Prop\ItemGroup=WG_AddBoxItem(gpList,Prop\name)
				Prop\ItemProp=WG_AddBoxItem(tbGroup,Prop\name)
		End Select
		
		WG_SetElementDragnDrop(Prop\id, 1)
		WG_SetElementGroup(Prop\id, vGroup)
		WG_SetElementLabel(Prop\id, vLable)
		WG_SetElementHelp(Prop\id, vHelp)
		WG_SetElementTextAlign(Prop\id, vTextAlign)
		WG_SetElementAlpha(Prop\id, vAlpha)
		WG_LockElement(Prop\id, vLock)
	Wend
	
	CloseFile(file)
	
	Prop = Null
	
	WG_MessageBox("","    : "+filename,"Ok",7,1)
End Function

Function SaveElem(E.TElem,file%,ParentName$="")
	WriteInt file, WG_ElementType(E\id)
	WriteString file, E\name
	WriteString file, E\groupName
	WriteString file, ParentName
	WriteInt file, E\hidden
	WriteInt file, E\moveble
	
	WriteInt file, WG_ElementX(E\id)
	WriteInt file, WG_ElementY(E\id)
	WriteInt file, WG_ElementWidth(E\id)
	WriteInt file, WG_ElementHeight(E\id)
	WriteString file, WG_ElementLabel(E\id)
	WriteString file, WG_ElementHelp(E\id)
	WriteInt file, WG_ElementTextAlign(E\id)
	WriteFloat file, WG_ElementAlpha(E\id)
	WriteInt file, WG_ElementLockState(E\id)
End Function

Function ExportElem(E.TElem,file%,PrNm$="")
	Local G.TElement=Object.TElement(E\id),T.TElem,length%,width%
	
	Select WG_ElementType(E\id)
		Case WGGroup
			WriteLine file,E\name+" = WG_CreateGroup()"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGWindow
			WriteLine file,"; ----------===  - "+E\name+" - "+G\label+" ===----------"
			WriteLine file,""
			WriteLine file,E\name+" = WG_CreateWindow("+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGButton
			WriteLine file,E\name+" = WG_CreateButton("+PrNm+","+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGToggleButton
			WriteLine file,E\name+" = WG_CreateToggleButton("+PrNm+","+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+",0,0,"+WG_ElementToggle(E\id)+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGCheckBox
			WriteLine file,E\name+" = WG_CreateCheckBox("+PrNm+","+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+","+G\textAlign+","+WG_ElementToggle(E\id)+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGOptionButton
			WriteLine file,E\name+" = WG_CreateOptionButton("+PrNm+","+E\groupName+","+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+","+WG_ElementToggle(E\id)+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
		Case WGLabel
			Local TL.TLabel=Object.TLabel(G\element)
			WriteLine file,E\name+" = WG_CreateLabel("+PrNm+","+G\x+","+G\y+","+Chr(34)+G\label+Chr(34)+","+G\width+","+G\height+","+TL\centerX+","+TL\centerY+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGImage
;			WriteLine file,E\name+" = WG_CreateImage("+PrNm+","+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+","+G\textAlign+","+WG_ElementToggle(E\id)+")"
;			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
;			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
;			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
;			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
;			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
;			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGTextBox
			Local TTB.TTextBox=Object.TTextBox(G\element)
			WriteLine file,E\name+" = WG_CreateTextBox("+PrNm+","+G\x+","+G\y+","+G\width+","+Chr(34)+G\label+Chr(34)+","+TTB\maxLen+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGTextArea
			Local TTA.TTextArea=Object.TTextArea(G\element), label$=Replace(G\label,Chr(10),Chr(34)+"+Chr(10)+"+Chr(34))
			WriteLine file,E\name+" = WG_CreateTextArea("+PrNm+","+G\x+","+G\y+","+G\width+","+TTA\rows+","+Chr(34)+label+Chr(34)+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGListBox
			Local TLB.TListBox=Object.TListBox(G\element)
			WriteLine file,E\name+" = WG_CreateListBox("+PrNm+","+G\x+","+G\y+","+G\width+","+TLB\stringCount+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGComboBox
			Local TCB.TComboBox=Object.TComboBox(G\element)
			WriteLine file,E\name+" = WG_CreateComboBox("+PrNm+","+G\x+","+G\y+","+G\width+","+TCB\stringCount+","+Chr(34)+G\label+Chr(34)+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGScrollBar
			Local TSB.TScrollBar=Object.TScrollBar(G\element)
			Select TSB\direction
				Case 0,3	;	
					length=G\width
					width=G\height
				Case 1,2	;	
					width=G\width
					length=G\height
			End Select
			WriteLine file,E\name+" = WG_CreateScrollBar("+PrNm+","+G\x+","+G\y+","+length+","+TSB\sliderLen+","+TSB\direction+","+TSB\minVal+","+TSB\maxVal+","+TSB\value+","+TSB\barStyle+",1,"+width+")"
			If G\textAlign<>0 Then WriteLine file,"WG_SetElementTextAlign("+E\name+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGFrame
			WriteLine file,E\name+" = WG_CreateFrame("+PrNm+","+G\x+","+G\y+","+G\width+","+G\height+","+Chr(34)+G\label+Chr(34)+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
		Case WGDivider
			If G\element=0 Then length=G\width Else length=G\height
			WriteLine file,E\name+" = WG_CreateDivider("+PrNm+","+G\x+","+G\y+","+length+","+G\element+","+Chr(34)+G\label+Chr(34)+","+G\textAlign+")"
			If G\help<>"" Then WriteLine file,"WG_SetElementHelp("+E\name+","+Chr(34)+G\help+Chr(34)+")"
			If G\alpha<>1 Then WriteLine file,"WG_SetElementAlpha("+E\name+","+G\alpha+")"
			If E\hidden<>0 Then WriteLine file,"WG_HideElement("+E\name+")"
			If G\lock<>0 Then WriteLine file,"WG_LockElement("+E\name+")"
			If E\moveble<>0 Then WriteLine file,"WG_SetElementDragnDrop("+E\name+",True)"
			If E\groupName<>"" Then WriteLine file,"WG_SetElementGroup("+E\name+","+E\groupName+")"
	End Select
	
	WriteLine file,""
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D