;====================================================================
; Project:		GUIw512 Style Test
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	   "Test"
;
;                   
;====================================================================

Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;	----------===  GUI ===----------
Include "..\B3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\B3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

SetFont LoadFont ("Tahoma",16)

;-----------------  GUI
Local win_buttons%,win_optionBs%,win_scrolls%,menuUpRus%,menuUpEng%,menuDown%,toolbar%
Local contextMenu%,contextMenuDef%
Local font=LoadImageFont("..\media\fonts\font.txt")

;-----------------  
menuUpRus=WG_CreateMenu(1,1," ")
menuUpEng=WG_CreateMenu(1,0,"Main menu")
menuDown=WG_CreateMenu(0,1,"  ()")

;-----------------   
toolbar=WG_CreateToolBar(1,1," ")

;-----------------     
tool_=		WG_CreateButton(toolbar,0,0,0,0,"",LoadTexture("..\media\icon_new.png",2),1,0,1)
tool_open=	WG_CreateButton(toolbar,0,0,0,0,"",LoadTexture("..\media\icon_open.png",2),1,0,1)
tool_save=	WG_CreateButton(toolbar,0,0,0,0,"",LoadTexture("..\media\icon_save.png",2),1,0,1)
tool_=		WG_CreateButton(toolbar,0,0,0,0,"",LoadTexture("..\media\icon_cut.png",2),1,0,1)
tool_=		WG_CreateButton(toolbar,0,0,0,0,"",LoadTexture("..\media\icon_copy.png",2),1,0,1)
tool_past=	WG_CreateToggleButton(toolbar,0,0,0,0,"",LoadTexture("..\media\icon_past.png",2),1,0,1)

;-----------------    
menuR_=			WG_AddMenuItem(menuUpRus,"")
menuR_=			WG_AddMenuItem(menuUpRus,"\","Ctrl+N",False,LoadTexture("..\media\icon_new.png",2),1)
menuR_open=		WG_AddMenuItem(menuUpRus,"\","Ctrl+O",False,LoadTexture("..\media\icon_open.png",2),1)
menuR_save=		WG_AddMenuItem(menuUpRus,"\","Ctrl+S",False,LoadTexture("..\media\icon_save.png",2),1)
menuR_exit=		WG_AddMenuItem(menuUpRus,"\")

menuR_edit=		WG_AddMenuItem(menuUpRus,"")
menuR_copy=		WG_AddMenuItem(menuUpRus,"\","Ctrl+C")
menuR_past=		WG_AddMenuItem(menuUpRus,"\","Ctrl+P")
menuR_delet=	WG_AddMenuItem(menuUpRus,"\")
menuR_=			WG_AddMenuItem(menuUpRus,"\\ ")
menuR_=			WG_AddMenuItem(menuUpRus,"\\")

menuR_search=	WG_AddMenuItem(menuUpRus,"")
menuR_=			WG_AddMenuItem(menuUpRus,"\")
menuR_=			WG_AddMenuItem(menuUpRus,"\")

menuR_=			WG_AddMenuItem(menuUpRus,"")
menuR_=			WG_AddMenuItem(menuUpRus,"\ ")
menuR_=			WG_AddMenuItem(menuUpRus,"\ ","",True)
menuR_=			WG_AddMenuItem(menuUpRus,"\ ")

menuR_=			WG_AddMenuItem(menuUpRus,"")
menuR_=			WG_AddMenuItem(menuUpRus,"\  ")

menuR_=			WG_AddMenuItem(menuUpRus,"")
menuR_=			WG_AddMenuItem(menuUpRus,"\")

menuR_=			WG_AddMenuItem(menuUpRus,"")
menuR_about=	WG_AddMenuItem(menuUpRus,"\ ...")
menuR_=			WG_AddMenuItem(menuUpRus,"\ ")

;-----------------    
WG_AddMenuItem(menuUpEng,"File")
WG_AddMenuItem(menuUpEng,"File\New")
WG_AddMenuItem(menuUpEng,"File\Open")
WG_AddMenuItem(menuUpEng,"File\Save")
WG_AddMenuItem(menuUpEng,"File\Exit")

WG_AddMenuItem(menuUpEng,"Edit")
WG_AddMenuItem(menuUpEng,"Edit\Copy")
WG_AddMenuItem(menuUpEng,"Edit\Past")
WG_AddMenuItem(menuUpEng,"Edit\Delete")

WG_AddMenuItem(menuUpEng,"Search")
WG_AddMenuItem(menuUpEng,"Search\Find")
WG_AddMenuItem(menuUpEng,"Search\Replace")

WG_AddMenuItem(menuUpEng,"View")
WG_AddMenuItem(menuUpEng,"View\Toolbar")
WG_AddMenuItem(menuUpEng,"View\ ")
WG_AddMenuItem(menuUpEng,"View\ ")

WG_AddMenuItem(menuUpEng,"Windows")
WG_AddMenuItem(menuUpEng,"Windows\Tram param param")

WG_AddMenuItem(menuUpEng,"Settings")
WG_AddMenuItem(menuUpEng,"Settings\Parararararam")

WG_AddMenuItem(menuUpEng,"Help")
menuE_about=WG_AddMenuItem(menuUpEng,"Help\About...")
WG_AddMenuItem(menuUpEng,"Help\Command list")

;-----------------    
WG_AddMenuItem(menuDown,"")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\")

WG_AddMenuItem(menuDown,"")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\\ ")
WG_AddMenuItem(menuDown,"\\-")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\\ ")
WG_AddMenuItem(menuDown,"\\")

WG_AddMenuItem(menuDown,"")
WG_AddMenuItem(menuDown,"\")
WG_AddMenuItem(menuDown,"\")

;-----------------   
contextMenu=WG_CreateContexMenu()
contextMenuDef=WG_CreateContexMenu()

;-----------------     
context_alpha02=	WG_AddContextMenuItem(contextMenu,"=0.2")
context_alpha06=	WG_AddContextMenuItem(contextMenu,"=0.6")
context_alpha10=	WG_AddContextMenuItem(contextMenu,"=1.0")
context_lock=		WG_AddContextMenuItem(contextMenu,"")
context_unlock=		WG_AddContextMenuItem(contextMenu,"")
context_=			WG_AddContextMenuItem(contextMenu,"")
context_=			WG_AddContextMenuItem(contextMenu,"\ 1")
context_=			WG_AddContextMenuItem(contextMenu,"\ 2")
context_=			WG_AddContextMenuItem(contextMenu,"\ 3")

;-----------------     
WG_AddContextMenuItem(contextMenuDef,"")
WG_AddContextMenuItem(contextMenuDef,"")
WG_AddContextMenuItem(contextMenuDef,"")
WG_AddContextMenuItem(contextMenuDef,"")

;-----------------    
WG_SetContextMenuDefault(contextMenuDef)

;-----------------       
WG_SetContextMenuElementType(contextMenu,WGWindow)
WG_SetContextMenuElementType(contextMenu,WGButton)
WG_SetContextMenuElementType(contextMenu,WGToggleButton)
WG_SetContextMenuElementType(contextMenu,WGOptionButton)
WG_SetContextMenuElementType(contextMenu,WGCheckBox)
WG_SetContextMenuElementType(contextMenu,WGTextBox)
WG_SetContextMenuElementType(contextMenu,WGScrollBar)
WG_SetContextMenuElementType(contextMenu,WGLabel)
WG_SetContextMenuElementType(contextMenu,WGListBox)
WG_SetContextMenuElementType(contextMenu,WGComboBox)

;	----------===   ===----------
Pointe=WG_CreatePointer(LoadImageEx("..\media\pointer.png",2,0))
PointerInput=WG_CreatePointer(LoadImageEx("..\media\pointer_input.png",2,0),3,8)
PointerHelp=WG_CreatePointer(LoadImageEx("..\media\pointer_help.png",2,0))

;	----------===   ===----------
WG_SetPointer(Pointe)
WG_SetPointerInput(PointerInput)
WG_SetPointerHelp(PointerHelp)

;-----------------  
win_buttons=WG_CreateWindow(50,100,300,200,"",0,1,1,1)
win_optionBs=WG_CreateWindow(323,155,200,270,"OptionButtons",0,1,1,1)
win_scrolls=WG_CreateWindow(500,220,250,310,"",0,1,1,1)
win_about=WG_CreateWindow(270,150,256,256," ",0,0,1,1)
WG_HideElement(win_about)

;-----------------   ""
button_alphaUp=		WG_CreateButton(win_buttons,15,10,0,0,". ",WGV_IconScrollUp,0,0,1)
button_alphaDown=	WG_CreateButton(win_buttons,15,35,0,0," .",WGV_IconScrollDown,0,0,1)
combobox=			WG_CreateComboBox(win_buttons,160,35,120,4," ","||||"," :",3)
button_textalign=	WG_CreateButton(win_buttons,150,85,0,0," textalign",LoadAnimTexture("..\media\icon_aero_color.png",11,32,32,0,55),2,6,0)
check_alpha=		WG_CreateCheckBox(win_buttons,50,110,200,54,"    . (     -    .)")
textbox=			WG_CreateTextBox(win_buttons,175,175,110," ",80)
label_mouseFree=	WG_CreateLabel(win_buttons,10,174,"MouseFree=0",0,0,0,0,2,0,font)

WG_SetElementHelp(button_alphaUp," ")
WG_SetElementHelp(button_alphaDown," ")

;-----------------   
WG_SetElementDragnDrop(button_alphaDown,1)

;-----------------   
WGAnim\frFirst[WGV_StatePassive]=18
WGAnim\frLast[WGV_StatePassive]=53
WGAnim\frRate[WGV_StatePassive]=70
WGAnim\animType[WGV_StatePassive]=WGV_AnimLoopForward

WGAnim\frFirst[WGV_StateActive]=0
WGAnim\frLast[WGV_StateActive]=17
WGAnim\frRate[WGV_StateActive]=30
WGAnim\animType[WGV_StateActive]=WGV_AnimLoopForward

WGAnim\frFirst[WGV_StatePressed]=0
WGAnim\frLast[WGV_StatePressed]=17
WGAnim\frRate[WGV_StatePressed]=30
WGAnim\animType[WGV_StatePressed]=WGV_AnimPingPongBack

WGAnim\frFirst[WGV_StateLock]=54
WGAnim\frLast[WGV_StateLock]=54
WGAnim\frRate[WGV_StateLock]=200
WGAnim\animType[WGV_StateLock]=0
WG_SetElementAnimation(button_textalign,WGAnim)

;-----------------   OptionButtons
group_winAlpha=		WG_CreateGroup()
group_winVisible=	WG_CreateGroup()
group_butMove=		WG_CreateGroup()
group_butLocke=		WG_CreateGroup()

WG_CreateLabel(win_optionBs,100,10," '':",0,0,1)
WG_CreateLabel(win_optionBs,100,190," 'OptionButtons':",0,0,1)

option_winAlpha5=	WG_CreateOptionButton(win_optionBs,group_winAlpha,20,35,150,15,"  - 0.5")
option_winAlpha10=	WG_CreateOptionButton(win_optionBs,group_winAlpha,20,55,150,15,"  - 1.0",1)
option_winHide=		WG_CreateOptionButton(win_optionBs,group_winVisible,20,85,150,15," ")
option_winShow=		WG_CreateOptionButton(win_optionBs,group_winVisible,20,105,150,15," ",1)
option_wLockMove=	WG_CreateOptionButton(win_optionBs,group_butMove,20,135,150,15," ")
option_wUnlockMove=	WG_CreateOptionButton(win_optionBs,group_butMove,20,155,150,15," ",1)
option_LockWin=		WG_CreateOptionButton(win_optionBs,group_butLocke,20,215,150,15," ")
option_UnLockWin=	WG_CreateOptionButton(win_optionBs,group_butLocke,20,235,150,15," ",1)

;-----------------   
but_about=WG_CreateButton(win_scrolls,113,83,0,0,"",LoadTexture("..\media\LogoSun.png",2),1,0,1)

scroll_1=WG_CreateScrollBar(win_scrolls,35,30,140,9,1,50,200,75,0,3)
scroll_2=WG_CreateScrollBar(win_scrolls,195,30,140,19,2,128,640,512,1,6)
scroll_3=WG_CreateScrollBar(win_scrolls,70,40,110,9,0,50,150,75,0,3)
scroll_4=WG_CreateScrollBar(win_scrolls,70,130,110,19,3,64,320,128,1,6)

WG_SetElementTextAlign(scroll_1,1)
WG_SetElementTextAlign(scroll_2,1)
WG_SetElementTextAlign(scroll_3,2)
WG_SetElementTextAlign(scroll_4,1)

WG_SetScrollBarMarking(scroll_1,25,1)
WG_SetScrollBarMarkingPart(scroll_2,4,1)
WG_SetScrollBarMarking(scroll_3,25,1)
WG_SetScrollBarMarkingPart(scroll_4,4,1)

WG_SetScrollBarStep(scroll_1,10)

label_=WG_CreateLabel(win_scrolls,10,275,"      ,   ",230)
listbox=WG_CreateListBox(win_scrolls,25,190,200,4,"",2,":",3)

;-----------------   " "
image=WG_CreateImage(win_about,0,0,LoadTexture("..\media\LogoTex.png"))
logo_gui=WG_CreateImage(win_about,53,10,LoadTexture("..\media\Logo_GUIw512.png",2),150,64,64)
WG_SetElementHelp(logo_gui,"GUIw512 v."+WGVersion)
;WG_CreateLabel(win_about,128,30,"GUIw512 v."+WGVersion,0,0,1,0,2,0,font)
WG_CreateLabel(win_about,0,190,"by wolfhound512"+Chr(10)+"www.SiberianSun.ru",256,0,1,0,2,10,font)
;WG_CreateLabel(win_about,0,180,"GUIw512 v."+WGVersion+Chr(10)+"by wolfhound512"+Chr(10)+"www.SiberianSun.ru",256,0,1,0,2,0,font)

;-----------------  
WG_AddBoxItem(listbox," 1| 2",LoadTexture("..\media\icon_folder.png",2),1,False)
WG_AddBoxItem(listbox," 1| 2| 3",LoadTexture("..\media\icon_file.png",2),1,False)
WG_AddBoxItem(listbox,"",LoadTexture("..\media\icon_web.png",2),1,False)
WG_AddBoxItem(listbox,"",LoadTexture("..\media\icon_search.png",2),1,False)
WG_AddBoxItem(listbox,"",LoadTexture("..\media\icon_help.png",2),1,False)
WG_AddBoxItem(listbox," ")

WG_LockElement(menuR_past)
WG_LockElement(menuR_search)
WG_SetElementToggle(check_alpha,1)

;	----------===  3  ===----------
CreateWorld()

HidePointer()

While KeyHit(1)=0
	
;==========-	RenderWorld

	RenderWorld

;==========-	UpDate GUI
	
	StartDraw()
	
	GUIw512_UpDate()
	
	EndDraw()
	
	If KeyHit(2) Then WG_ShowElement(win_buttons)
	If KeyHit(3) Then WG_SetBoxSelectNum(listbox,7)
	If KeyHit(4) Then WG_SetBoxSelectNum(listbox,3)
	
	If WG_CheckElementExist(win_buttons) Then
	;-----------------   MouseFree (    GUI  )
		WG_SetElementLabel(label_mouseFree,"MouseFree="+WG_MouseFree())
	;-----------------   
		If MilliSecs()-timer>50 Then
			timer=MilliSecs()
			x=x+10
			y=y+3
			If x>250 Then x=-240
			If y>250 Then y=-240
			WG_SetCustomColor(label_mouseFree,WG_GetRGB(10,250,Abs(y)),WG_GetRGB(10,250,10),WG_GetRGB(250,Abs(x),250),WG_GetRGB(250,Abs(y),250-Abs(x)))
		EndIf
	EndIf
	
;-----------------   
	Select WG_GetEvent()
		Case WGV_EventTextBoxInput
			WG_MessageBox(" "," : "+WG_EventLabel())
		Case WGV_EventElementClick
			Select WG_EventSource()
				Case button_alphaUp
					If WG_ElementToggle(check_alpha)=True Then
						WG_SetElementAlpha(win_buttons,WG_ElementAlpha(win_buttons)-.05)
;						WG_UnSetOptionButton(group_winAlpha)
					EndIf
				Case button_alphaDown
					If WG_ElementToggle(check_alpha)=True Then
						WG_SetElementAlpha(win_buttons,WG_ElementAlpha(win_buttons)+.05)
;						WG_UnSetOptionButton(group_winAlpha)
					EndIf
				Case button_textalign
					textalign=textalign+1
					If textalign>3 Then textalign=0
					WG_SetElementTextAlign check_alpha,textalign
				Case tool_open
					WG_MessageBox("","  : '"+WG_RequestFileName(200,80,0,"  (*.*)| (*.bmp; *.png)")+"'")
				Case tool_save
					WG_MessageBox("","  : '"+WG_RequestFileName(200,80,1,"BMP (*.bmp; *.rle)|JPG (*.jpg)|PNG (*.png)|Video (*.avi)")+"'")
				Case but_about
					WG_ShowElement(win_about)
					WG_ActivateWindowE(win_about)
			End Select
		Case WGV_EventOptionButtonSelect
			If WG_CheckWindowExist(win_buttons) Then
				Select WG_EventSource()
					Case option_winAlpha5
						WG_SetElementAlpha(win_buttons,.5)
					Case option_winAlpha10
						WG_SetElementAlpha(win_buttons,1)
					Case option_winShow
						WG_ShowElement(win_buttons)
					Case option_winHide
						WG_HideElement(win_buttons)
					Case option_wLockMove
						WG_LockElement(win_buttons)
					Case option_wUnlockMove
						WG_UnLockElement(win_buttons)
					Case option_LockWin
						WG_LockWindow(win_optionBs)
					Case option_UnLockWin
						WG_LockWindow(0)
				End Select
			Else
				Select WG_EventSource()
					Case option_LockWin
						WG_LockWindow(win_optionBs)
					Case option_UnLockWin
						WG_LockWindow(0)
				End Select
			EndIf
		Case WGV_EventWindowChangeState
			Select WG_EventSource()
				Case win_about
					If WG_EventState()=WGV_WindowClose Then WG_SetWindowState(win_about,WGV_WindowHide)
			End Select
		Case WGV_EventMenuSelect
			Select WG_EventSource()
				Case menuR_exit
					End
				Case menuR_about,menuE_about
					WG_ShowElement(win_about)
					WG_ActivateWindowE(win_about)
			End Select
		Case WGV_EventMenuChangeState
			If WG_EventState()=WGV_StateMoveEnd Then
				If WG_EventData()=1 Then
					stat$="WGV_MenuFixed"
				Else
					stat$="WGV_MenuFreePosition"
				EndIf
				WG_MessageBox(" ","  '"+WG_EventLabel()+"'"+Chr(10)+"   - "+stat$+",   : x="+WG_EventX()+", y="+WG_EventY(),"Ok",115)
			EndIf
		Case WGV_EventScrollBarScrolling
		Case WGV_EventContextMenuSelect
			Select WG_EventData()
				Case win_buttons
					If WG_ElementToggle(check_alpha)=True Then ok=1 Else ok=0
				Default
					ok=1
			End Select
			If ok=1 Then
				Select WG_EventSource()
					Case context_alpha02
						WG_SetElementAlpha(WG_EventData(),0.2)
					Case context_alpha06
						WG_SetElementAlpha(WG_EventData(),0.6)
					Case context_alpha10
						WG_SetElementAlpha(WG_EventData(),1.0)
					Case context_lock
						WG_LockElement(WG_EventData(),1)
					Case context_unlock
						WG_LockElement(WG_EventData(),0)
				End Select
			EndIf
		Case WGV_EventMessageBoxSelect
		Case WGV_EventBoxSelect
			WG_MessageBox(" "," : "+WG_EventLabel())
	End Select
	
	Color 100,110,120
	Text GraphicsWidth() Shr 1,5,WGV_FPS,1
	Flip 0
Wend

GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=CreateLight()
	RotateEntity light,45,-60,0
	cam=CreateCamera()
	CameraClsColor cam,10,20,30
	cub=CreateCube()
	RotateEntity cub,-10,-20,-10
	tex=LoadTexture("..\media\LogoTex.png")
	EntityTexture cub,tex
	PositionEntity cub,-3,-1.7,6
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D