;====================================================================
; Project:		GUIw512 ColorScheme Editor
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	  
;
;                   
;====================================================================

Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

;	----------===  GUI ===----------
Include "..\B3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\B3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

SetFont LoadFont ("Tahoma",16)

Global scroll_R%,scroll_G%,scroll_B%,scroll_ratio_R%,scroll_ratio_G%,scroll_ratio_B%,back_from_main%=0
Global scroll_text_R%,scroll_text_G%,scroll_text_B%,scroll_ratio_text_R%,scroll_ratio_text_G%,scroll_ratio_text_B%

Global Camera%

Local i%,back_R%=10,back_G%=20,back_B%=30
Local win_colors_main%,win_colors_text%,win_colors_background%,win_demonstration%
Local scroll_back_R%,scroll_back_G%,scroll_back_B%
Local check_back%,button_save%,button_load%,group_schemes%,label_scheme%,option_scheme%[4],menu_scheme%[4],menu_scheme_rnd%
Local filename$,format$="Color scheme (*.txt)"

;	----------===  3  ===----------
CreateWorld()

;-----------------------    -----------------------
win_colors_main=WG_CreateWindow(70,35,290,320,"  ",0,1,1,1)
WG_CreateLabel(win_colors_main,145,10," ",0,0,1)
WG_CreateLabel(win_colors_main,20,50,"")
WG_CreateLabel(win_colors_main,20,90,"")
WG_CreateLabel(win_colors_main,20,130,"")
scroll_R=WG_CreateScrollBar(win_colors_main,80,50,160,9,0,0,255,WGV_R,0,3)
scroll_G=WG_CreateScrollBar(win_colors_main,80,90,160,9,0,0,255,WGV_G,0,3)
scroll_B=WG_CreateScrollBar(win_colors_main,80,130,160,9,0,0,255,WGV_B,0,3)
WG_SetElementTextAlign(scroll_R,4)
WG_SetElementTextAlign(scroll_G,4)
WG_SetElementTextAlign(scroll_B,4)
WG_SetScrollBarMarkingPart(scroll_R,6,2)
WG_SetScrollBarMarkingPart(scroll_G,6,2)
WG_SetScrollBarMarkingPart(scroll_B,6,2)
WG_CreateLabel(win_colors_main,140,160," ",0,0,1)
WG_CreateLabel(win_colors_main,20,200,"")
WG_CreateLabel(win_colors_main,20,240,"")
WG_CreateLabel(win_colors_main,20,280,"")
scroll_ratio_R=WG_CreateScrollBar(win_colors_main,80,200,160,9,0,0,200,WGV_RatioR*100,0,3)
scroll_ratio_G=WG_CreateScrollBar(win_colors_main,80,240,160,9,0,0,200,WGV_RatioG*100,0,3)
scroll_ratio_B=WG_CreateScrollBar(win_colors_main,80,280,160,9,0,0,200,WGV_RatioB*100,0,3)
WG_SetElementTextAlign(scroll_ratio_R,4)
WG_SetElementTextAlign(scroll_ratio_G,4)
WG_SetElementTextAlign(scroll_ratio_B,4)
WG_SetScrollBarMarkingPart(scroll_ratio_R,6,2,0,1,.01)
WG_SetScrollBarMarkingPart(scroll_ratio_G,6,2,0,1,.01)
WG_SetScrollBarMarkingPart(scroll_ratio_B,6,2,0,1,.01)

;------------------------    -------------------------
win_colors_text=WG_CreateWindow(430,35,290,320,"  ",0,1,1,1)
WG_CreateLabel(win_colors_text,140,10," ",0,0,1)
WG_CreateLabel(win_colors_text,20,50,"")
WG_CreateLabel(win_colors_text,20,90,"")
WG_CreateLabel(win_colors_text,20,130,"")
scroll_text_R=WG_CreateScrollBar(win_colors_text,80,50,160,9,0,0,255,WGV_TextColorR,0,3)
scroll_text_G=WG_CreateScrollBar(win_colors_text,80,90,160,9,0,0,255,WGV_TextColorG,0,3)
scroll_text_B=WG_CreateScrollBar(win_colors_text,80,130,160,9,0,0,255,WGV_TextColorB,0,3)
WG_SetElementTextAlign(scroll_text_R,4)
WG_SetElementTextAlign(scroll_text_G,4)
WG_SetElementTextAlign(scroll_text_B,4)
WG_SetScrollBarMarkingPart(scroll_text_R,6,2)
WG_SetScrollBarMarkingPart(scroll_text_G,6,2)
WG_SetScrollBarMarkingPart(scroll_text_B,6,2)
WG_CreateLabel(win_colors_text,140,160," ",0,0,1)
WG_CreateLabel(win_colors_text,20,200,"")
WG_CreateLabel(win_colors_text,20,240,"")
WG_CreateLabel(win_colors_text,20,280,"")
scroll_ratio_text_R=WG_CreateScrollBar(win_colors_text,80,200,160,9,0,0,200,WGV_TextRatioR*100,0,3)
scroll_ratio_text_G=WG_CreateScrollBar(win_colors_text,80,240,160,9,0,0,200,WGV_TextRatioG*100,0,3)
scroll_ratio_text_B=WG_CreateScrollBar(win_colors_text,80,280,160,9,0,0,200,WGV_TextRatioB*100,0,3)
WG_SetElementTextAlign(scroll_ratio_text_R,4)
WG_SetElementTextAlign(scroll_ratio_text_G,4)
WG_SetElementTextAlign(scroll_ratio_text_B,4)
WG_SetScrollBarMarkingPart(scroll_ratio_text_R,6,2,0,1,.01)
WG_SetScrollBarMarkingPart(scroll_ratio_text_G,6,2,0,1,.01)
WG_SetScrollBarMarkingPart(scroll_ratio_text_B,6,2,0,1,.01)

;-------------------------    --------------------------
win_colors_background=WG_CreateWindow(30,400,290,160,"  ",0,1,1,1)
WG_CreateLabel(win_colors_background,140,10," ",0,0,1)
WG_CreateLabel(win_colors_background,20,50,"")
WG_CreateLabel(win_colors_background,20,75,"")
WG_CreateLabel(win_colors_background,20,100,"")
scroll_back_R=WG_CreateScrollBar(win_colors_background,80,50,160,9,0,0,255,back_R,0,3)
scroll_back_G=WG_CreateScrollBar(win_colors_background,80,75,160,9,0,0,255,back_G,0,3)
scroll_back_B=WG_CreateScrollBar(win_colors_background,80,100,160,9,0,0,255,back_B,0,3)
WG_SetElementTextAlign(scroll_back_R,4)
WG_SetElementTextAlign(scroll_back_G,4)
WG_SetElementTextAlign(scroll_back_B,4)
WG_SetScrollBarMarkingPart(scroll_back_R,6,2)
;WG_SetScrollBarMarkingPart(scroll_back_G,6,2)
;WG_SetScrollBarMarkingPart(scroll_back_B,6,2)
check_back=WG_CreateCheckBox(win_colors_background,30,130,250,20,"    ")
WG_SetElementToggle(check_back,back_from_main)

;-----------------------   ------------------------
win_demonstration=WG_CreateWindow(370,400,400,160," ",0,1,1,1)
button_save=WG_CreateButton(win_demonstration,20,15,80,0,"")
button_load=WG_CreateButton(win_demonstration,110,15,80,0,"")
group_schemes=WG_CreateGroup()
label_scheme=WG_CreateLabel(win_demonstration,0,0," ",110,0,1)
WG_PositionElement(label_scheme,340,10,1,0)
option_scheme[0]=WG_CreateOptionButton(win_demonstration,group_schemes,305,50,80,20,"  1")
option_scheme[1]=WG_CreateOptionButton(win_demonstration,group_schemes,305,70,80,20,"  2")
option_scheme[2]=WG_CreateOptionButton(win_demonstration,group_schemes,305,90,80,20,"  3")
option_scheme[3]=WG_CreateOptionButton(win_demonstration,group_schemes,305,110,80,20,"  4")
option_scheme[4]=WG_CreateOptionButton(win_demonstration,group_schemes,305,130,80,20,"  5")
button_lock=WG_CreateButton(win_demonstration,20,45,60,0,"Lock")
toggle_lock=WG_CreateToggleButton(win_demonstration,90,45,100,0,"Lock & Toggled")
toggle_unlock=WG_CreateToggleButton(win_demonstration,20,75,170,0,"Toggle Button - Toggled")
check_lock=WG_CreateCheckBox(win_demonstration,20,105,120,14,"Locked CheckBox")
textbox_unlock=WG_CreateTextBox(win_demonstration,20,129,75,"TextBox",50)
textbox_lock=WG_CreateTextBox(win_demonstration,105,129,85,"TextBox Locked",50)
scroll_lock=WG_CreateScrollBar(win_demonstration,240,20,120,17,2,256,1024,512,1,2)
WG_SetElementTextAlign(scroll_lock,4)
WG_SetScrollBarMarkingPart(scroll_lock,6,2)
WG_SetElementToggle(toggle_lock,1)
WG_SetElementToggle(toggle_unlock,1)
WG_SetElementToggle(check_lock,1)
WG_LockElement(button_lock)
WG_LockElement(toggle_lock)
WG_LockElement(check_lock)
WG_LockElement(textbox_lock)
;WG_LockElement(scroll_lock)

;-----------------------   ------------------------
menu=WG_CreateMenu()
WG_AddMenuItem(menu,"")
WG_AddMenuItem(menu,"\")
menu_load=WG_AddMenuItem(menu,"\","Ctrl+O")
menu_save=WG_AddMenuItem(menu,"\","Ctrl+S")
menu_exit=WG_AddMenuItem(menu,"\","Ctrl+Q")

WG_AddMenuItem(menu," ")
menu_scheme[0]=WG_AddMenuItem(menu," \  1","Ctrl+1")
menu_scheme[1]=WG_AddMenuItem(menu," \  2","Ctrl+2")
menu_scheme[2]=WG_AddMenuItem(menu," \  3","Ctrl+3")
menu_scheme[3]=WG_AddMenuItem(menu," \  4","Ctrl+4")
menu_scheme[4]=WG_AddMenuItem(menu," \  5","Ctrl+5")
menu_scheme_rnd=WG_AddMenuItem(menu," \","Ctrl+Enter")

WG_AddMenuItem(menu,"")
WG_AddMenuItem(menu,"\")
WG_AddMenuItem(menu,"\")
WG_AddMenuItem(menu,"\")

WG_AddMenuItem(menu,"\")
WG_AddMenuItem(menu,"\\")
WG_AddMenuItem(menu,"\\")
WG_AddMenuItem(menu,"\\")

WG_AddMenuItem(menu,"\")

For i=1 To 5
	If WG_SetColorScheme(i)=0 Then
		WG_LockElement(option_scheme[i-1])
		WG_LockElement(menu_scheme[i-1])
	EndIf
Next

scheme%=2
WG_SetColorScheme(scheme)
WG_SetElementToggle(option_scheme[scheme-1],1)
UpDateScrollBar()

If back_from_main=True Then
	CameraClsColor Camera,WGV_R,WGV_G,WGV_B
	WG_LockElement(scroll_back_R)
	WG_LockElement(scroll_back_G)
	WG_LockElement(scroll_back_B)
Else
	CameraClsColor Camera,back_R,back_G,back_B
	WG_UnLockElement(scroll_back_R)
	WG_UnLockElement(scroll_back_G)
	WG_UnLockElement(scroll_back_B)
EndIf

WG_SetFileReqStart(CurrentDir())

;	----------===   ===----------
While KeyHit(1)=0
	
;	----------=== RenderWorld ===----------
	RenderWorld
	
	If KeyDown(29)=True Or KeyDown(157)=True Then
		For i=2 To 6
			If KeyHit(i) Then
				If WG_SetColorScheme(i-1)=True Then
					UpDateScrollBar()
					WG_SetElementToggle(option_scheme[i-2],1)
				EndIf
			EndIf
		Next
		If KeyHit(28)=True Then
			RND_Scheme()
			WG_UnSetOptionButton(group_schemes)
		EndIf
		If KeyHit(24)=True Then
			filename=WG_RequestFileName(120,100,0,format)
			If filename<>"" Then
				If WG_LoadColorScheme(filename)=1 Then
					WG_MessageBox("","     : "+filename,"Ok",3)
					UpDateScrollBar()
					WG_UnSetOptionButton(group_schemes)
				Else
					WG_MessageBox("","    ","Ok",3)
				EndIf
			EndIf
		EndIf
		If KeyHit(31)=True Then
			filename=WG_RequestFileName(120,100,1,format)
			If filename<>"" Then
				WG_SaveColorScheme(filename)
				WG_MessageBox("","    : "+filename,"Ok",3)
			EndIf
		EndIf
		If KeyHit(16)=True Then
			End
		EndIf
	EndIf
	
;	----------=== UpDate GUI ===----------
	StartDraw()
	
	GUIw512_UpDate()
	
	EndDraw()
	
;	----------===   ===----------
	Select WG_GetEvent()
		Case WGV_EventElementClick
			Select WG_EventSource()
				Case check_back
					back_from_main=WG_EventState()
					If back_from_main=True Then
						CameraClsColor Camera,WGV_R,WGV_G,WGV_B
						WG_LockElement(scroll_back_R)
						WG_LockElement(scroll_back_G)
						WG_LockElement(scroll_back_B)
					Else
						CameraClsColor Camera,back_R,back_G,back_B
						WG_UnLockElement(scroll_back_R)
						WG_UnLockElement(scroll_back_G)
						WG_UnLockElement(scroll_back_B)
					EndIf
				Case button_save
					filename=WG_RequestFileName(120,100,1,format)
					If filename<>"" Then
						WG_SaveColorScheme(filename)
						WG_MessageBox("","    : "+filename,"Ok",3)
					EndIf
				Case button_load
					filename=WG_RequestFileName(120,100,0,format)
					If filename<>"" Then
						If WG_LoadColorScheme(filename)=1 Then
							WG_MessageBox("","     : "+filename,"Ok",3)
							UpDateScrollBar()
							WG_UnSetOptionButton(group_schemes)
						Else
							WG_MessageBox("","    ","Ok",3)
						EndIf
					EndIf
				Case toggle_unlock
					If WG_EventState()=1
						WG_SetElementLabel(toggle_unlock,"Toggle Button - Toggled")
					Else
						WG_SetElementLabel(toggle_unlock,"Toggle Button - UnToggled")
					EndIf
			End Select
		Case WGV_EventOptionButtonSelect
			WG_SetColorScheme(Int(Right(WG_EventLabel(),1)))
			UpDateScrollBar()
		Case WGV_EventScrollBarScrolling
			Select WG_EventSource()
				Case scroll_R
					WGV_R=WG_EventData()
					WG_UnSetOptionButton(group_schemes)
					If back_from_main=True Then CameraClsColor Camera,WGV_R,WGV_G,WGV_B
				Case scroll_G
					WGV_G=WG_EventData()
					WG_UnSetOptionButton(group_schemes)
					If back_from_main=True Then CameraClsColor Camera,WGV_R,WGV_G,WGV_B
				Case scroll_B
					WGV_B=WG_EventData()
					WG_UnSetOptionButton(group_schemes)
					If back_from_main=True Then CameraClsColor Camera,WGV_R,WGV_G,WGV_B
				Case scroll_ratio_R
					WGV_RatioR=Float(WG_EventData())/100.0
					WG_UnSetOptionButton(group_schemes)
				Case scroll_ratio_G
					WGV_RatioG=Float(WG_EventData())/100.0
					WG_UnSetOptionButton(group_schemes)
				Case scroll_ratio_B
					WGV_RatioB=Float(WG_EventData())/100.0
					WG_UnSetOptionButton(group_schemes)
				Case scroll_text_R
					WGV_TextColorR=WG_EventData()
					WG_UnSetOptionButton(group_schemes)
				Case scroll_text_G
					WGV_TextColorG=WG_EventData()
					WG_UnSetOptionButton(group_schemes)
				Case scroll_text_B
					WGV_TextColorB=WG_EventData()
					WG_UnSetOptionButton(group_schemes)
				Case scroll_ratio_text_R
					WGV_TextRatioR=Float(WG_EventData())/100.0
					WG_UnSetOptionButton(group_schemes)
				Case scroll_ratio_text_G
					WGV_TextRatioG=Float(WG_EventData())/100.0
					WG_UnSetOptionButton(group_schemes)
				Case scroll_ratio_text_B
					WGV_TextRatioB=Float(WG_EventData())/100.0
					WG_UnSetOptionButton(group_schemes)
				Case scroll_back_R
					back_R=WG_EventData()
					CameraClsColor Camera,back_R,back_G,back_B
				Case scroll_back_G
					back_G=WG_EventData()
					CameraClsColor Camera,back_R,back_G,back_B
				Case scroll_back_B
					back_B=WG_EventData()
					CameraClsColor Camera,back_R,back_G,back_B
			End Select
		Case WGV_EventWindowChangeState
			If WG_EventState()=WGV_WindowClose Then
				WG_MessageBox("","   ,    .   ,    .","Ok",3)
				WG_SetWindowState(WG_EventSource(),WGV_WindowMinimize)
			EndIf
		Case WGV_EventMenuSelect
			If Left(WG_EventLabel(),5)="" Then
				i=Int(Right(WG_EventLabel(),1))
				WG_SetColorScheme(i)
				WG_SetElementToggle(option_scheme[i-1],1)
				UpDateScrollBar()
			Else
				Select WG_EventSource()
					Case menu_scheme_rnd
						RND_Scheme()
						WG_UnSetOptionButton(group_schemes)
					Case menu_save
						filename=WG_RequestFileName(120,100,1,format)
						If filename<>"" Then
							WG_SaveColorScheme(filename)
							WG_MessageBox("","    : "+filename,"Ok",3)
						EndIf
					Case menu_load
						filename=WG_RequestFileName(120,100,0,format)
						If filename<>"" Then
							If WG_LoadColorScheme(filename)=1 Then
								WG_MessageBox("","     : "+filename,"Ok",3)
								UpDateScrollBar()
								WG_UnSetOptionButton(group_schemes)
							Else
								WG_MessageBox("","    ","Ok",3)
							EndIf
						EndIf
					Case menu_exit
						End
				End Select
			EndIf
		Case WGV_EventMenuChangeState
		Case WGV_EventContextMenuSelect
		Case WGV_EventMessageBoxSelect
	End Select
	
;	----------===  FPS ===----------
	Color 100,100,100
	Text GraphicsWidth() Shr 1,5,WGV_FPS,1
	
	Flip 0
Wend

End

Function WG_SaveColorScheme(filename$)
	Local file%
	file=WriteFile(filename)
	WriteLine file,";#  "
	WriteLine file,"WGV_R = "+WGV_R
	WriteLine file,"WGV_G = "+WGV_G
	WriteLine file,"WGV_B = "+WGV_B
	WriteLine file,";#    "
	WriteLine file,"WGV_RatioR = "+WGV_RatioR
	WriteLine file,"WGV_RatioG = "+WGV_RatioG
	WriteLine file,"WGV_RatioB = "+WGV_RatioB
	WriteLine file,";#  "
	WriteLine file,"WGV_TextColorR = "+WGV_TextColorR
	WriteLine file,"WGV_TextColorG = "+WGV_TextColorG
	WriteLine file,"WGV_TextColorB = "+WGV_TextColorB
	WriteLine file,";#    "
	WriteLine file,"WGV_TextRatioR = "+WGV_TextRatioR
	WriteLine file,"WGV_TextRatioG = "+WGV_TextRatioG
	WriteLine file,"WGV_TextRatioB = "+WGV_TextRatioB
End Function

Function UpDateScrollBar()
	WG_SetScrollBarValue(scroll_R,WGV_R)
	WG_SetScrollBarValue(scroll_G,WGV_G)
	WG_SetScrollBarValue(scroll_B,WGV_B)
	WG_SetScrollBarValue(scroll_ratio_R,WGV_RatioR*100)
	WG_SetScrollBarValue(scroll_ratio_G,WGV_RatioG*100)
	WG_SetScrollBarValue(scroll_ratio_B,WGV_RatioB*100)
	WG_SetScrollBarValue(scroll_text_R,WGV_TextColorR)
	WG_SetScrollBarValue(scroll_text_G,WGV_TextColorG)
	WG_SetScrollBarValue(scroll_text_B,WGV_TextColorB)
	WG_SetScrollBarValue(scroll_ratio_text_R,WGV_TextRatioR*100)
	WG_SetScrollBarValue(scroll_ratio_text_G,WGV_TextRatioG*100)
	WG_SetScrollBarValue(scroll_ratio_text_B,WGV_TextRatioB*100)
	If back_from_main=True Then CameraClsColor Camera,WGV_R,WGV_G,WGV_B
End Function

Function RND_Scheme()
	WGV_R=Rnd(0,255)
	WGV_G=Rnd(0,255)
	WGV_B=Rnd(0,255)
	WGV_RatioR=Rnd(0,2)
	WGV_RatioG=Rnd(0,2)
	WGV_RatioB=Rnd(0,2)
	WGV_TextColorR=Rnd(0,255)
	WGV_TextColorG=Rnd(0,255)
	WGV_TextColorB=Rnd(0,255)
	WGV_TextRatioR=Rnd(0,2)
	WGV_TextRatioG=Rnd(0,2)
	WGV_TextRatioB=Rnd(0,2)
	UpDateScrollBar()
End Function

Function CreateWorld()
	Local light%,cub%,tex%
	
	light=CreateLight()
	RotateEntity light,45,-60,0
	Camera=CreateCamera()
	CameraClsColor Camera,10,20,30
	cub=CreateCube()
	RotateEntity cub,-10,-20,-10
	tex=LoadTexture("..\media\LogoTex.png")
	EntityTexture cub,tex
	PositionEntity cub,-3,-1.7,6
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D