;====================================================================
; Project:		GUIw512 Sample Pointer
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	
;
;
;====================================================================

Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;	----------===  GUI ===----------
Include "..\B3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\B3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

SetFont LoadFont ("Tahoma",16)

;	----------===  GUI ===----------
Local window%

;	----------===   ===----------
window = WG_CreateWindow(100,50,600,500,"",0,1)

valid = LoadTexture("..\media\img_valid.png")
invalid = LoadTexture("..\media\img_invalid.png")

image = WG_CreateImage(window, 30, 30, invalid, 200, 150, 0)
WG_SetElementDescription(image, "200x150:", 1)

image = WG_CreateImage(window, 30, 210, invalid, 200, 150, 1)
WG_SetElementDescription(image, "200x150 + :", 1)

image = WG_CreateImage(window, 270, 30, valid, 256, 256, 4 + 16 + 64, 200, 150)
WG_SetElementDescription(image, "256256  = 4 + 16 + 64:", 1)

image = WG_CreateImage(window, 270, 210, valid, 256, 256)
WG_SetElementDescription(image, "256256 :", 1)

;	----------===  3  ===----------
CreateWorld()

;	----------===   ===----------
While KeyHit(1)=0
	
;	----------=== RenderWorld ===----------
	RenderWorld
	
;	----------=== UpDate GUI ===----------
	StartDraw()
	
	GUIw512_UpDate()
	
	EndDraw()
	
;	----------===   ===----------
	Select WG_GetEvent()
	;	----------===    ===----------
		Case WGV_EventElementClick
		;	----------===    ===----------
			Select WG_EventSource()
					
			End Select
	End Select
	
;	----------===  FPS ===----------
	Color 100,110,120
	Text GraphicsWidth() Shr 1,5,WGV_FPS,1
	Flip 0
Wend

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=CreateLight()
	RotateEntity light,45,-60,0
	cam=CreateCamera()
	CameraClsColor cam,10,20,30
	cub=CreateCube()
	RotateEntity cub,-10,-20,-10
	tex=LoadTexture("..\media\LogoTex.png")
	EntityTexture cub,tex
	PositionEntity cub,-3,-1.7,6
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D