;====================================================================
; Project:		GUIw512 Sample WindowsAndButtons
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	      
;				    
;                   
;====================================================================

;	----------===  Xors3D ===----------
Include "..\X3D_include\Xors3D.bb"

xGraphics3D 800,600,32,0
xSetBuffer xBackBuffer()

;	----------===  GUI ===----------
Include "..\X3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\X3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

xSetFont xLoadFont ("Tahoma",16)

;	----------===  GUI ===----------
Local window1%,window2%
Local button1%,button2%,button3%,button4%,button5%,button6%

;	----------===   ===----------

; WG_CreateWindow% (x%, y%, width%, height%, title$ [,titleAlign%=0] [,help%=0] [,minimize%=1]
;				[,close%=1] [,icon%=0] [,icontype%=0] [,alphatype%=0])
;		:
; x%,y% -    
; width%,height% -  . 
; title$ -   . 
; titleAlign% -   . 
; help% (.) -     .   . 
; minimize% (.) -   .   . 
; close% (.) -   .   . 
; icon% (.) -  . 
; icontype% (.) -  ,    WG_CreateButton() 
; alphatype% (.) -    : 
;		0 -    ,     ; 
;		1 -    ,      .

window=WG_CreateWindow(400,150,200,210,"",0,0,1,1,xLoadTexture("..\media\icon_help.png",2),1)

;	----------===   ===----------

; WG_CreateButton% (parent%, x%, y%, width%, height%, label$ [,icon%=0] [,icontype%=0] [,style%=0] [,flag%=0])
;		:
; parent% -     (,    ..). 
; x%, y% -    . 
; width% -  .    0,       . 
; height% -  .    0,       . 
; label$ -  . 
; icon% (.) -  . 
; icontype% (.) -  : 
;		0 -  ,   icon   ; 
;		1 -  ,   icon    ; 
;		2 -  ,   icon     .
;			       WG_SetElementAnimation(). 
; flag% (.) : 
;		0 -   
;		1 -   
;		2 -      X 
;		4 -      Y 
; style% (.) -   .       .

;          
;    "GUIw512_Style_Test.bb"     :
; WGV_IconTick, WGV_IconPoint, WGV_IconFurl, WGV_IconClose, WGV_IconArrowForward
; WGV_IconScrollUp, WGV_IconScrollDown, WGV_IconScrollLeft, WGV_IconScrollRight

button1=WG_CreateButton(window,100,20,0,0," ",0,0,2)
button2=WG_CreateToggleButton(window,100,50,0,0,"-",0,0,2)
button3=WG_CreateButton(window,100,80,0,0,"   ",WGV_IconArrowForward,0,2)
button3=WG_CreateButton(window,100,110,0,0,"   ",xLoadTexture("..\media\icon_file.png",2),1,2)
button4=WG_CreateButton(window,100,140,0,0,"  1",0,0,2,1)
button6=WG_CreateButton(window,100,170,0,0," ",0,0,3)

;      2
;   6   1+2=3

;	----------===  3  ===----------
CreateWorld()

;	----------===   ===----------
While xKeyHit(1)=0 Or xWinMessage("WM_CLOSE")
	
;	----------=== xRenderWorld ===----------
	xRenderWorld
	
;	----------=== UpDate GUI ===----------
	xStartDraw()
	
	GUIw512_UpDate()
	
	xEndDraw()
	
;	----------===   ===----------
	Select WG_GetEvent()
			
	;	==============================================
	;	----------===    ===----------
		Case WGV_EventElementClick
			
		;	----------===    (   ) ===----------
			Select WG_EventSource()
					
			;	----------===     1 ===----------
				Case button1
					;	- 
					label=WG_EventLabel()	; -    . 
					
			;	----------===     2 ===----------
				Case button2
					;	- 
					label=WG_EventLabel()	; -    . 
					state=WG_EventState()	; -    ,
					;    - (togglebutton).	
					; true -  / false - .
					
			;	----------===     3 ===----------
				Case button3
					;	...  ..
			End Select
			
		;	----------===   ===----------
			;     ,    
			;         .
			
			;     :
			; WG_SetElementLabel( _  _ , _ _ )
			
			; WG_EventSource() -     
			; WG_EventLabel() -    
			
			WG_SetElementLabel(WG_EventSource(),Int(WG_EventLabel())+1)
			
			; ..  6    1,     
			;     .
			
	;	================================================
	;	----------===   ===----------
		Case WGV_EventElementDown
			
		;	----------===    (  ) ===----------
			Select WG_EventSource()
					
			;	----------===    1 ===----------
				Case button1
					;	- 
					label=WG_EventLabel()	; -    . 
					
			;	----------===    2 ===----------
				Case button2
					;	- 
					label=WG_EventLabel()	; -    . 
					
			;	----------===    3 ===----------
				Case button3
					;	...  ..
			End Select
			
	;	====================================================
	;	----------===    ===----------
		Case WGV_EventWindowChangeState
			
		;	----------===    (,    ) ===----------
			Select WG_EventSource()
					
			;	----------===     1 ===----------
				Case window1
					;	- 
					label=WG_EventLabel()	; -   
					state=WG_EventState()	; -   
					
				;	----------===     ===----------
					Select state
						Case WGV_WindowMinimize		; -  
						Case WGV_WindowMaximize		; -  
						Case WGV_WindowHide			; -   (  ,  WGV_WindowCloseType=1)
						Case WGV_WindowClose		; -   (  ,  WGV_WindowCloseType=0)
						Case WGV_StateMoveStart		; -   
						Case WGV_StateMoving		; -  
						Case WGV_StateMoveEnd		; -  
					End Select
					;  WGV_WindowCloseType     GUIw512.bb   ""
					;    ,         ""
					;    "  \ "
					
			;	----------===     2 ===----------
				Case window2
					;	...  ..
			End Select
			
	;	====================================================
	;	----------===      ===----------
		Case WGV_EventWindowHelpClick
			
		;	----------===    (,     ) ===----------
			Select WG_EventSource()
					
			;	----------===      1 ===----------
				Case window1
					;	    1
					label=WG_EventLabel()	; -   
					
			;	----------===      2 ===----------
				Case window2
					;	    2
					;	...  ..
			End Select
	End Select
	
;	----------===  FPS ===----------
	xColor 100,110,120
	xText xGraphicsWidth() Shr 1,5,WGV_FPS,1
	
	xFlip
Wend

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=xCreateLight()
	xRotateEntity light,45,-60,0
	cam=xCreateCamera()
	xCameraClsColor cam,10,20,30
	xCameraZoom cam,.3
	cub=xCreateCube()
	xRotateEntity cub,-10,-20,-10
	tex=xLoadTexture("..\media\LogoTex.png")
	xEntityTexture cub,tex
	xPositionEntity cub,-3,-1.7,6
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D