;====================================================================
; Project:		GUIw512 Sample FileRequester
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	   
;
;
;====================================================================

Include "..\X3D_include\Xors3D.bb"

xGraphics3D 800,600,32,0
xSetBuffer xBackBuffer()

;	----------===  GUI ===----------
Include "..\X3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\X3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

xSetFont xLoadFont ("Tahoma",16)

;	----------===  GUI ===----------
Local window%,button_save%,button_open%
Local filename$

;	----------===   ===----------
window=WG_CreateWindow(350,200,200,100,"",0,1,1,1)

;	----------===    FileRequester' ===----------
button_save=WG_CreateButton(window,100,20,0,0," ",xLoadTexture("..\media\icon_save.png",2),1,2,1)
button_open=WG_CreateButton(window,100,60,0,0," ",xLoadTexture("..\media\icon_open.png",2),1,2,1)

;	----------===     FileRequester' ===----------

; WG_SetFileReqStart% ([adress$=""] [,filename$=""])
;		:
; adress$ (.) -  . 
; filename$ (.) -   .
;		:
;   ,      
;    WG_RequestFileName().    
;       ,      . 
;     ,     .

WG_SetFileReqStart(CurrentDir())

; WG_RequestFileName$ ([x%=0] [,y%=0] [,FRtype%=0] [,formats$="All files (*.*)"]
;						[,adress$=""] [,filename$=""] [,winName$=""])
;		:
; x%, y% (.) -  . 
; FRtype% (.) -  : 
;		0 -  
;		1 -  
; formats$ (.) -   . 
; adress$ (.) -  . 
; filename$ (.) -   . 
; winName$ (.) -  .
;		:
;          .
;           . 
;    formats$   :   
;     ,     
;       ,    
;  "|".       "*.*" . 
; : formats$ = "  (*.*)| (*.bmp; *.png)"

;	----------===  3  ===----------
CreateWorld()

;	----------===   ===----------
While xKeyHit(1)=0
	
;	----------=== xRenderWorld ===----------
	xRenderWorld
	
;	----------=== UpDate GUI ===----------
	xStartDraw()
	
	GUIw512_UpDate()
	
	xEndDraw()
	
;	----------===   ===----------
	Select WG_GetEvent()
	;	----------===    ===----------
		Case WGV_EventElementClick
		;	----------===    ===----------
			Select WG_EventSource()
					
			;	----------===  "" ===----------
				Case button_open
					filename=WG_RequestFileName(200,80,0,"  (*.*)| (*.bmp; *.png)")
					
				;	----------===     -   ,     ===----------
					If filename<>"" Then
						WG_MessageBox("","  : '"+filename+"'")
					Else
						WG_MessageBox("","   ")
					EndIf
					
			;	----------===  "" ===----------
				Case button_save
					filename=WG_RequestFileName(200,80,1,"BMP (*.bmp; *.rle)|JPG (*.jpg)|PNG (*.png)|Video (*.avi)")
					
				;	----------===     -   ,     ===----------
					If filename<>"" Then
						WG_MessageBox("","  : '"+filename+"'")
					Else
						WG_MessageBox("","   ")
					EndIf
			End Select
	End Select
	
;	----------===  FPS ===----------
	xColor 100,110,120
	xText xGraphicsWidth() Shr 1,5,WGV_FPS,1
	xFlip
Wend

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=xCreateLight()
	xRotateEntity light,45,-60,0
	cam=xCreateCamera()
	xCameraClsColor cam,10,20,30
	xCameraZoom cam,.3
	cub=xCreateCube()
	xRotateEntity cub,-10,-20,-10
	tex=xLoadTexture("..\media\LogoTex.png")
	xEntityTexture cub,tex
	xPositionEntity cub,-3,-1.7,6
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D