;====================================================================
; Project:		GUIw512 Sample Pointer
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	   
;
;
;====================================================================

Include "..\X3D_include\Xors3D.bb"

xGraphics3D 800,600,32,0
xSetBuffer xBackBuffer()

;	----------===  GUI ===----------
Include "..\X3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\X3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

xSetFont xLoadFont ("Tahoma",16)

;	----------===  GUI ===----------
Local window%,text_area%,text_box%
Local txt$

txt="Project:         GUIw512 Sample Pointer"
txt=txt+Chr(10)+"Version:         " + WGVersion
txt=txt+Chr(10)+"Author:          wolfhound512"
txt=txt+Chr(10)+"Email:             support@siberiansun.ru"
txt=txt+Chr(10)+"Copyright:      wolfhound512"
txt=txt+Chr(10)+"Description:       "

;	----------===   ===----------
window=WG_CreateWindow(350,200,300,210,"",0,1)

;	----------===    FileRequester' ===----------
text_box=WG_CreateTextBox(window,20,30,160,"GUIw512 v."+WGVersion,40)
text_area=WG_CreateTextArea(window,20,80,260,7,txt,1024,0,300)

WG_SetElementDescription(text_box,":",1,0)
WG_SetElementDescription(text_area," :",1,0)

;	----------===   ===----------

; WG_CreatePointer% (imageFI% [,handleX%=0] [,handleY%=0] [,animType%=0] [,frames%=0] [,animDelay%=0])
;		:
; imageFI% -    FastImage     xLoadImageEx()  xLoadAnimImageEx() 
; handleX% -    X 
; handleY% -    Y 
; animType% -  : 
;		WGV_AnimStop -  
;		WGV_AnimLoopForward -    
;		WGV_AnimLoopBack -    
;		WGV_AnimOneShotForward -    
;		WGV_AnimOneShotBack -    
;		WGV_AnimPingPong - - ,   -  
;		WGV_AnimPingPongBack - - ,   -  
; frames% -     
; animDelay% -     

Pointe=WG_CreatePointer(xLoadImageEx("..\media\pointer.png",2,0))
PointerInput=WG_CreatePointer(xLoadImageEx("..\media\pointer_input.png",2,0),3,8)
PointerHelp=WG_CreatePointer(xLoadImageEx("..\media\pointer_help.png",2,0))

;	----------===   ===----------
WG_SetPointer(Pointe)
WG_SetPointerInput(PointerInput)
WG_SetPointerHelp(PointerHelp)

;	----------===  3  ===----------
CreateWorld()

HidePointer()

;	----------===   ===----------
While xKeyHit(1)=0
	
;	----------=== xRenderWorld ===----------
	xRenderWorld
	
;	----------=== UpDate GUI ===----------
	xStartDraw()
	
	GUIw512_UpDate()
	
	xEndDraw()
	
;	----------===   ===----------
	Select WG_GetEvent()
	;	----------===    ===----------
		Case WGV_EventElementClick
		;	----------===    ===----------
			Select WG_EventSource()
					
			End Select
	End Select
	
;	----------===  FPS ===----------
	xColor 100,110,120
	xText xGraphicsWidth() Shr 1,5,WGV_FPS,1
	xFlip
Wend

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=xCreateLight()
	xRotateEntity light,45,-60,0
	cam=xCreateCamera()
	xCameraClsColor cam,10,20,30
	xCameraZoom cam,.3
	cub=xCreateCube()
	xRotateEntity cub,-10,-20,-10
	tex=xLoadTexture("..\media\LogoTex.png")
	xEntityTexture cub,tex
	xPositionEntity cub,-3,-1.7,6
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D