;===============================================
;====			: Test					====
;===============================================
;====			 GUIw512 Blitz			====
;====			version 1.07.0.0			====
;===============================================
;====			Created by					====
;====			wolfhound512				====
;===============================================
;====			www.SiberianSun.ru			====
;====			Support@SiberianSun.ru		====
;===============================================

;=======-		   FastImage		-=======
Const WGV_FI_LineWidth%=1
;=======-		   			-=======
Const WGV_CheckBoxSize%=16,WGV_OptionButtonSize%=12
Const WGV_IconWidth%=16,WGV_IconHeight%=16,WGV_Space%=10,WGV_SpaceMini%=4
Const WGV_HeaderHeightW%=25,WGV_HeaderHeightM%=22,WGV_WindowBorderWidth%=3
Const WGV_MenuEShift%=4,WGV_MenuEShiftWithHeader%=10
Const WGV_MenuWidthExtend%=10,WGV_MenuHeightExtend%=4
Const WGV_ContextMenuWidthExtend%=4,WGV_ContextMenuHeightExtend%=4
Const WGV_ButtonMenuWidthExtend%=10,WGV_ButtonMenuHeightExtend%=4
Const WGV_ButtonContextMenuIndent%=5
Const WGV_ButtonWidthExtendT%=20,WGV_ButtonHeightExtendT%=8
Const WGV_ButtonWidthExtendI%=6,WGV_ButtonHeightExtendI%=6
Const WGV_TextBoxHeightExtend%=5,WGV_TextBoxWidthExtend%=7,WGV_TextBoxTextStartX%=4
Const WGV_ListBoxWidthExtend%=2,WGV_ListBoxHeightExtend%=2,WGV_ButtonListBoxHeightExtend%=6
Const WGV_ListBoxItemsX%=1,WGV_ListBoxItemsY%=1,WGV_ListBoxSpace%=2
Const WGV_ComboBoxHeightExtend%=6
Const WGV_ScrollBarWidth%=16,WGV_ButtonScrollBarHeight%=16
Const WGV_HelpMaxWidth%=300,WGV_HelpIndent%=10
Const WGV_MsgBoxMinWidth%=220,WGV_MsgBoxMaxWidth%=500,WGV_MsgBoxIndent%=15
;WGV_SubMenuHeight#=1.2,WGV_ScrollWidth%=16
;=======-		 			-=======
Const WGV_Border%=105,WGV_MidLightBorder%=75,WGV_LightBorder%=50,WGV_LightedBorder%=15
Const WGV_DarkFon%=60,WGV_Fon%=45,WGV_MidLightFon%=30,WGV_LightFon%=20,WGV_LightedFon%=10,WGV_LockFon%=25
Const WGV_LockText%=95,WGV_LightText%=70,WGV_LightedText%=160;,WG_IconColor%=250
;=======-								-=======

Function WG_LoadStyleMedia(path$="..\media\style_test\",fontname$="Tahoma.txt")
	Local pIcons$=path+"icons\"
	
	WGV_Font=xLoadImageFont(path+fontname)
	If WGV_Font=0 Then RuntimeError "      "+CurrentDir()+path+fontname
	xSetImageFont WGV_Font
	
	WGV_IIconFile=xLoadTexture(pIcons+"file.png",2)
	WGV_IIconFolder=xLoadTexture(pIcons+"folder.png",2)
	WGV_IIconMyDocs=xLoadTexture(pIcons+"mydocs.png",2)
	WGV_IIconPublic=xLoadTexture(pIcons+"public.png",2)
	WGV_IIconHDD%=xLoadTexture(pIcons+"hdd.png",2)
	WGV_IIconCDROM=xLoadTexture(pIcons+"cdrom.png",2)
	WGV_IIconUSB=xLoadTexture(pIcons+"usb.png",2)
	WGV_IIconNetwork=xLoadTexture(pIcons+"network.png",2)
	WGV_IIconRAM=0
	WGV_IIconUnknown=0
End Function

Function WG_DrawMenu(x%,y%,width%,height%,label$,alpha#,state%,lock%)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255)
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_MenuFixed
		;=======-  -=======
			WG_SetColorF WGV_LightedFon,0,0
			xDrawLineSimple(x,y,x+width,y)
			WG_SetColorF WGV_Border,0,0
			xDrawLineSimple(x,y+height,x+width,y+height)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x,y+1,width,height-1,1)
		;=======-  -=======
			If lock=0 Then
				WG_SetColorF WGV_Border,0,0
				xDrawLineSimple(x+5,y+2,x+5,y+height-3)
				xDrawLineSimple(x+3,y+height-2,x+5,y+height-2)
				WG_SetColorF 0,0,0
				xDrawPlot(x+4,y+2)
				xDrawLineSimple(x+3,y+2,x+3,y+height-3)
			EndIf
		Case WGV_MenuFreePosition
		;=======-  -=======
			WG_SetColorF WGV_Border,0,0
			xDrawRectSimple(x,y,width,WGV_HeaderHeightM+height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,WGV_HeaderHeightM+height-2,1)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+2,y+2,width-4,WGV_HeaderHeightM-3,1)
		;=======-  -=======
			If label<>"" Then
				WG_SetColorF 0,1,0
				xDrawText label,x+10,y+(WGV_HeaderHeightM Shr 1),0,1
			EndIf
	End Select
End Function

Function WG_DrawContextMenu(x%,y%,width%,height%,alpha#)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),alphaIntF%
	Local colorB%,colorLB%,colorMLB%,colorLdB%
	
	;=======-    -=======
	xSetAlpha(alpha)
	
	;=======-  -=======
	WG_SetColorF WGV_Border,0,0
	xDrawRectSimple(x,y,width,height,0)
	;=======-  -=======
	color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
	color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
	xSetCustomColor(color0,color1,color2,color3)
	xDrawRectSimple(x+1,y+1,width-2,height-2,1)
End Function

Function WG_DrawPointer(image,hX,hY,frame)
	xSetAlpha(1.0)
	xSetColor(255,255,255)
	xDrawImageEx(image,xMouseX()-hX,xMouseY()-hY,frame)
End Function

Function WG_DrawWindow(x%,y%,width%,height%,active%,label$,align%,space%,alpha#,state%,icon,iconType%,iconWidth%,iconHeight%,iconFrame%,alphaF#=0)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),alphaIntF%,textShift%
	Local colorB%,colorLB%,colorMLB%,colorLdB%
	
	;=======-    -=======
	xSetAlpha(alpha)
	;=======-       -=======
	Select active
		Case True
			colorB=WGV_Border
			colorMLB=WGV_MidLightBorder
			colorLB=WGV_LightBorder
			colorLdB=WGV_LightedBorder
		Case False
			colorB=WGV_MidLightBorder
			colorMLB=WGV_LightBorder
			colorLB=WGV_Fon
			colorLdB=WGV_LightedFon
	End Select
	Select state
		Case WGV_WindowMaximize	;	 
			;=======-  -=======
			WG_SetColorF colorB,0,0
			xDrawRectSimple(x,y,width,WGV_HeaderHeightW+height,0)
			xDrawRectSimple(x+2,y+WGV_HeaderHeightW-1,width-4,height-1,0)
			WG_SetColorF 0,0,0
			xDrawRectSimple(x+1,y+2,width-2,WGV_HeaderHeightW+height-3,0)
			;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+3,y+WGV_HeaderHeightW,width-6,height-3,1)
			;=======-  -=======
			WG_SetColorF colorLB,0,0
			xDrawLineSimple(x+1,y+1,x+width-2,y+1)
			xDrawLineSimple(x+1,y+3,x+width-2,y+3)
			color0=(alphaInt Shl 24) Or WG_GetColor(colorMLB) : color1=(alphaInt Shl 24) Or WG_GetColor(colorMLB)
			color3=(alphaInt Shl 24) Or WG_GetColor(colorLdB) : color2=(alphaInt Shl 24) Or WG_GetColor(colorLdB)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+4,width-2,WGV_HeaderHeightW-5,1)
			;=======-  -=======
			Select iconType
				Case 2,3
					xDrawImageEx(icon,x+6+iconWidth Shr 1,y+WGV_HeaderHeightW Shr 1,iconFrame)
					textShift=iconWidth
			End Select
			;=======-  -=======
			WG_SetColorF 0,1,0
			;xDrawTextRect(label$,x+12+textShift,y,width-space-textShift,WGV_HeaderHeightW,align,1)
			If WG_SetViewport(x+12+textShift,y,width-space-textShift-16,WGV_HeaderHeightW)<>0 Then
				Select align
					Case 0
						xDrawText(label$,x+12+textShift,y+WGV_HeaderHeightW Shr 1,0,1)
					Case 1
						xDrawText(label$,x+width Shr 1,y+WGV_HeaderHeightW Shr 1,1,1)
					Case 2
						xDrawText(label$,x+width-space-WGV_Space,y+WGV_HeaderHeightW Shr 1,2,1)
				End Select
				WG_SetViewport()
			EndIf
		Case WGV_WindowMinimize	;	 
			;=======-  -=======
			WG_SetColorF colorB,0,0
			xDrawRectSimple(x,y,width,WGV_HeaderHeightW,0)
			WG_SetColorF 0,0,0
			xDrawLineSimple(x+1,y+2,x+width-2,y+2)
			;=======-  -=======
			WG_SetColorF colorLB,0,0
			xDrawLineSimple(x+1,y+1,x+width-2,y+1)
			xDrawLineSimple(x+1,y+3,x+width-2,y+3)
			color0=(alphaInt Shl 24) Or WG_GetColor(colorMLB) : color1=(alphaInt Shl 24) Or WG_GetColor(colorMLB)
			color3=(alphaInt Shl 24) Or WG_GetColor(colorLdB) : color2=(alphaInt Shl 24) Or WG_GetColor(colorLdB)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+4,width-2,WGV_HeaderHeightW-5,1)
			;=======-  -=======
			Select iconType
				Case 2,3
					xDrawImageEx(icon,x+6+iconWidth Shr 1,y+WGV_HeaderHeightW Shr 1,iconFrame)
					textShift=iconWidth
			End Select
			;=======-  -=======
			WG_SetColorF 0,1,0
			If WG_SetViewport(x+12+textShift,y,width-space-textShift-16,WGV_HeaderHeightW)<>0 Then
				Select align
					Case 0
						xDrawText(label$,x+12+textShift,y+WGV_HeaderHeightW Shr 1,0,1)
					Case 1
						xDrawText(label$,x+width Shr 1,y+WGV_HeaderHeightW Shr 1,1,1)
					Case 2
						xDrawText(label$,x+width-space-WGV_Space,y+WGV_HeaderHeightW Shr 1,2,1)
				End Select
				WG_SetViewport()
			EndIf
		Case 3	;	 
			;=======-  -=======
			WG_SetColorF colorB,0,0
			xDrawRectSimple(x,y,width,WGV_HeaderHeightW,0)
			WG_SetColorF 0,0,0
			xDrawLineSimple(x+1,y+2,x+width-2,y+2)
			
			xSetAlpha(alphaF)
			xSetViewport(x,y+WGV_HeaderHeightW-1,width,height+1)
			alphaIntF=Int(alphaF*255)
			WG_SetColorF colorB,0,0
			xDrawRectSimple(x,y,width,WGV_HeaderHeightW+height,0)
			xDrawRectSimple(x+2,y+WGV_HeaderHeightW-1,width-4,height-1,0)
			WG_SetColorF 0,0,0
			xDrawRectSimple(x+1,y+2,width-2,WGV_HeaderHeightW+height-3,0)
			;=======-  -=======
			color0=(alphaIntF Shl 24) Or WG_GetColor(WGV_Fon) : color1=(alphaIntF Shl 24) Or WG_GetColor(WGV_Fon)
			color3=(alphaIntF Shl 24) Or WG_GetColor(WGV_Fon) : color2=(alphaIntF Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+3,y+WGV_HeaderHeightW,width-6,height-3,1)
			
			;=======-  -=======
			xSetAlpha(alpha)
			xSetViewport(0,0,-1,-1)
			WG_SetColorF colorLB,0,0
			xDrawLineSimple(x+1,y+1,x+width-2,y+1)
			xDrawLineSimple(x+1,y+3,x+width-2,y+3)
			color0=(alphaInt Shl 24) Or WG_GetColor(colorMLB) : color1=(alphaInt Shl 24) Or WG_GetColor(colorMLB)
			color3=(alphaInt Shl 24) Or WG_GetColor(colorLdB) : color2=(alphaInt Shl 24) Or WG_GetColor(colorLdB)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+4,width-2,WGV_HeaderHeightW-5,1)
			;=======-  -=======
			Select iconType
				Case 2,3
					xDrawImageEx(icon,x+6+iconWidth Shr 1,y+WGV_HeaderHeightW Shr 1,iconFrame)
					textShift=iconWidth
			End Select
			;=======-  -=======
			WG_SetColorF 0,1,0
			If WG_SetViewport(x+12+textShift,y,width-space-textShift-16,WGV_HeaderHeightW)<>0 Then
				Select align
					Case 0
						xDrawText(label$,x+12+textShift,y+WGV_HeaderHeightW Shr 1,0,1)
					Case 1
						xDrawText(label$,x+width Shr 1,y+WGV_HeaderHeightW Shr 1,1,1)
					Case 2
						xDrawText(label$,x+width-space-WGV_Space,y+WGV_HeaderHeightW Shr 1,2,1)
				End Select
				WG_SetViewport()
			EndIf
	End Select
End Function

Function WG_DrawButton(x%,y%,width%,height%,label$,icon,iconType%,iconWidth%,iconHeight%,iconFrame%,state%,alpha#,style%)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),tmpX%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	If WG_SetViewport(x,y,width,height)=0 Then Return
	
	Select style
		Case 0,WGV_StyleButtonWindow,WGV_StyleButtonScrollBar
	;-----------------   ----------------
			Select state
				Case WGV_StatePassive		;	 
				;=======-  -=======
					WG_SetColorF(WGV_MidLightBorder,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateActive		;	 
				;=======-  -=======
					WG_SetColorF(WGV_Border,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StatePressed,WGV_StateToggledPressed	;	 
				;=======-  -=======
					WG_SetColorF(WGV_Border,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1)+1,y+(height Shr 1)+1,1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth+1,y+(height Shr 1)+1,0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth+1,y+(height Shr 1)+1,0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateToggledPassive	;	  
				;=======-  -=======
					WG_SetColorF(WGV_MidLightBorder,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateToggledActive	;	  
				;=======-  -=======
					WG_SetColorF(WGV_Border,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedBorder)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateLock	;	 
				;=======-  -=======
					WG_SetColorF(WGV_LightBorder,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF WGV_LockText,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF WGV_LockText,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateToggledLock	;	 
				;=======-  -=======
					WG_SetColorF(WGV_LightBorder,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF WGV_LockText,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF WGV_LockText,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
			End Select
		Case 1
	;-----------------  1 ----------------
			Select state
				Case WGV_StatePassive			;	 
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateActive			;	 
				;=======-  -=======
					WG_SetColorF(WGV_Border,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StatePressed,WGV_StateToggledPressed	;	 
				;=======-  -=======
					WG_SetColorF(WGV_Border,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateToggledPassive	;	  
				;=======-  -=======
					WG_SetColorF(WGV_MidLightBorder,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateToggledActive		;	  
				;=======-  -=======
					WG_SetColorF(WGV_Border,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateLock			;	 
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF WGV_LockText,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF WGV_LockText,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
				Case WGV_StateToggledLock	;	  
				;=======-  -=======
					WG_SetColorF(WGV_LightBorder,0,0)
					xDrawRectSimple(x,y,width,height,0)
				;=======-  -=======
					color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					xSetCustomColor(color0,color1,color2,color3)
					xDrawRectSimple(x+1,y+1,width-2,height-2,1)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+(width Shr 1),y+(height Shr 1),1,1,x+2,y+2,width-4,height-4)
						Case 1
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								WG_DrawIcon(tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							Else
								WG_DrawIcon(x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							EndIf
						Case 2,3
							If label<>"" Then
								tmpX=x+(width-xStringWidthEx(label$)-iconWidth)/2
								WG_SetColorF 0,1,0
								WG_DrawText(label$,tmpX+iconWidth,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,tmpX-WGV_SpaceMini,y+(height-iconHeight)/2,iconFrame)
							Else
								xSetAlpha alpha*.2
								xSetColor 255,255,255
								xDrawImageEx(icon,x+(width-iconWidth)/2,y+(height-iconHeight)/2,iconFrame)
							EndIf
					End Select
			End Select
		Case WGV_StyleButtonListBox
	;-----------------   ----------------
			Select state
				Case WGV_StatePassive			;	 
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+WGV_SpaceMini,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 1
							WG_DrawIcon(x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 2,3
							xSetColor 255,255,255
							xDrawImageEx(icon,x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconFrame)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
					End Select
				Case WGV_StateActive			;	 
				;=======-  -=======
					WG_SetColorF(WGV_LightBorder,0,0)
					xDrawRectSimple(x,y,width,height)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+WGV_SpaceMini,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 1
							WG_DrawIcon(x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 2,3
							xSetColor 255,255,255
							xDrawImageEx(icon,x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconFrame)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
					End Select
				Case WGV_StatePressed,WGV_StateToggledPressed	;	 
				;=======-  -=======
					WG_SetColorF(WGV_DarkFon,0,0)
					xDrawRectSimple(x,y,width,height)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+WGV_SpaceMini,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 1
							WG_DrawIcon(x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 2,3
							xSetColor 255,255,255
							xDrawImageEx(icon,x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconFrame)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
					End Select
				Case WGV_StateToggledPassive,WGV_StateToggledActive	;	  ,   
				;=======-  -=======
					WG_SetColorF(WGV_MidLightBorder,0,0)
					xDrawRectSimple(x,y,width,height)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+WGV_SpaceMini,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 1
							WG_DrawIcon(x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconWidth,iconHeight,icon)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 2,3
							xSetColor 255,255,255
							xDrawImageEx(icon,x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconFrame)
							WG_SetColorF 0,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
					End Select
				Case WGV_StateLock			;	 
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+WGV_SpaceMini,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 1
							WG_DrawIcon(x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 2,3
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
							xSetAlpha alpha*.2
							xSetColor 255,255,255
							xDrawImageEx(icon,x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconFrame)
					End Select
				Case WGV_StateToggledLock	;	  
				;=======-  -=======
					;If alpha>.5 Then xSetAlpha(alpha/2)
					WG_SetColorF(WGV_Fon,0,0)
					xDrawRectSimple(x,y,width,height)
				;=======-    -=======
					Select iconType
						Case 0
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+WGV_SpaceMini,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 1
							WG_DrawIcon(x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconWidth,iconHeight,icon,1)
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
						Case 2,3
							WG_SetColorF WGV_LockText,1,0
							WG_DrawText(label$,x+iconWidth+WGV_ListBoxSpace Shl 1,y+(height Shr 1),0,1,x+2,y+2,width-4,height-4)
							xSetAlpha alpha*.2
							xSetColor 255,255,255
							xDrawImageEx(icon,x+WGV_ListBoxSpace,y+(height-iconHeight)/2,iconFrame)
					End Select
			End Select
	End Select
	
	WG_SetViewport()
End Function

Function WG_DrawCheckBox(x%,y%,width%,height%,state%,label$,textalign%,alpha#)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),y1%
	Local boxX%,boxY%,textX%,centerY%
	
;-----------------    ----------------
	xSetAlpha(alpha)
;-----------------    ----------------
	Select textalign
		Case 0
			boxX=x
			boxY=y
			textX=x+WGV_CheckBoxSize+(WGV_Space Shr 1)
			centerY=0
		Case 1
			boxX=x+width-WGV_CheckBoxSize
			boxY=y
			textX=x
			centerY=0
		Case 2
			boxX=x
			boxY=y+((height-WGV_CheckBoxSize) Shr 1)
			textX=x+WGV_CheckBoxSize+(WGV_Space Shr 1)
			centerY=1
		Case 3
			boxX=x+width-WGV_CheckBoxSize
			boxY=y+((height-WGV_CheckBoxSize) Shr 1)
			textX=x
			centerY=1
	End Select
	
;-----------------    ----------------
	Select state
		Case WGV_StatePassive	;	 
				;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateActive		;	 
				;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StatePressed	;	 
				;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledPassive	;	 
				;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,WGV_IconTick)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledActive	;	 
				;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,WGV_IconTick)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledPressed
				;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,WGV_IconTick)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateLock		;	 
				;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledLock	;	 
				;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,0)
				;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(boxX+1,boxY+1,WGV_CheckBoxSize-2,WGV_CheckBoxSize-2,1)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_CheckBoxSize,WGV_CheckBoxSize,WGV_IconTick,1)
				;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_CheckBoxSize-(WGV_Space Shr 1),height,4,centerY)
	End Select
End Function

Function WG_DrawOptionButton(x%,y%,width%,height%,state%,label$,textalign%,alpha#)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),y1%
	Local boxX%,boxY%,textX%,centerY%
	
;-----------------    ----------------
	xSetAlpha(alpha)
;-----------------    ----------------
	Select textalign
		Case 0
			boxX=x
			boxY=y
			textX=x+WGV_OptionButtonSize+(WGV_Space Shr 1)
			centerY=0
		Case 1
			boxX=x+width-WGV_OptionButtonSize
			boxY=y
			textX=x
			centerY=0
		Case 2
			boxX=x
			boxY=y+((height-WGV_OptionButtonSize) Shr 1)
			textX=x+WGV_OptionButtonSize+(WGV_Space Shr 1)
			centerY=0
		Case 3
			boxX=x+width-WGV_OptionButtonSize
			boxY=y+((height-WGV_OptionButtonSize) Shr 1)
			textX=x
			centerY=0
	End Select
	
;-----------------    ----------------
	Select state
		Case WGV_StatePassive	;	 
				;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_LightedFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateActive		;	 
				;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_LightedFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StatePressed	;	 
				;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_MidLightFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledPassive	;	 
				;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_LightedFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize,WGV_IconPoint)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledActive	;	 
				;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_LightedFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize,WGV_IconPoint)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledPressed
				;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_MidLightFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize,WGV_IconPoint)
				;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateLock	;	 
				;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_LockFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
		Case WGV_StateToggledLock	;	 
				;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawOval(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize)
				;=======-  -=======
			WG_SetColorF(WGV_LockFon,0,0)
			xDrawOval(boxX+1,boxY+1,WGV_OptionButtonSize-2,WGV_OptionButtonSize-2)
				;=======-  -=======
			WG_DrawIcon(boxX,boxY,WGV_OptionButtonSize,WGV_OptionButtonSize,WGV_IconPoint,1)
				;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			WG_DrawTextRect(label,textX,y,width-WGV_OptionButtonSize-(WGV_Space Shr 1),height,4,centerY)
	End Select
End Function

Function WG_DrawLabel(x%,y%,width%,height%,state%,label$,textalign%,alpha#,WG.TLabel)
	Local colorFull%[3],alphaInt%,colorT%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	If WG\font<>0 Then xSetImageFont WG\font
	
	Select state
		Case WGV_StateLock
			WG_SetColorF(WGV_LockText,1,0)
		Default
			Select WG\rgb[3]
				Case -2
					WG_SetColorF(0,1,0)
				Case -1
					xSetColor(WG\rgb[0],WG\rgb[1],WG\rgb[2])
				Default
					alphaInt%=Int(alpha*255)
					If WG\alpha[3]=-1 Then
						colorFull[0]=(alphaInt Shl 24) Or WG\rgb[0] : colorFull[1]=(alphaInt Shl 24) Or WG\rgb[1]
						colorFull[3]=(alphaInt Shl 24) Or WG\rgb[3] : colorFull[2]=(alphaInt Shl 24) Or WG\rgb[2]
					Else
						colorFull[0]=((WG\alpha[0]*alphaInt) Shl 24) Or WG\rgb[0] : colorFull[1]=((WG\alpha[1]*alphaInt) Shl 24) Or WG\rgb[1]
						colorFull[3]=((WG\alpha[3]*alphaInt) Shl 24) Or WG\rgb[3] : colorFull[2]=((WG\alpha[2]*alphaInt) Shl 24) Or WG\rgb[2]
					EndIf
					xSetCustomColor(colorFull[0],colorFull[1],colorFull[2],colorFull[3])
			End Select
	End Select
	
	If textalign=1 Then
		WG_DrawTextRect(label,x,y,width,height,WG\centerX+WG\transfer,WG\centerY,WG\lineSpacing,WG\cut)
	Else
		xDrawText(label,x,y,0,0)
	EndIf
	
	If WG\font<>0 Then xSetImageFont WGV_Font
End Function

Function WG_DrawImage(image%,x%,y%,frame%,state%,alpha#,width%,height%,noResize%)
	xSetAlpha(alpha)
	xSetColor 255,255,255
	
	If noResize=0 Then
		xDrawImageEx(image,x,y,frame)
	Else
		xDrawImagePart(image,x,y,width,height,0,0,width,height,frame)
	EndIf
End Function

Function WG_DrawTextBox(x%,y%,width%,height%,state%,label$,alpha#,textAlign%,cursor%=0,selStart%=0,selWidth%=0)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),cursorx%,cursory%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StatePassive
		;-----------------  ----------------
		;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			WG_SetColorF 0,1,0
			Select textAlign
				Case 0
					xDrawText(label$,x+WGV_TextBoxTextStartX,y+2,textAlign,0,width-WGV_TextBoxWidthExtend)
				Case 1
					WG_DrawText(label$,x+width Shr 1,y+2,textAlign,0,x+2,y+2,width-4,height-4)
				Case 2
					WG_DrawText(label$,x+width-WGV_TextBoxTextStartX,y+2,textAlign,0,x+2,y+2,width-4,height-4)
			End Select
		Case WGV_StateActive
		;-----------------  ----------------
		;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			WG_SetColorF 0,1,0
			Select textAlign
				Case 0
					xDrawText(label$,x+WGV_TextBoxTextStartX,y+2,textAlign,0,width-WGV_TextBoxWidthExtend)
				Case 1
					WG_DrawText(label$,x+width Shr 1,y+2,textAlign,0,x+2,y+2,width-4,height-4)
				Case 2
					WG_DrawText(label$,x+width-WGV_TextBoxTextStartX,y+2,textAlign,0,x+2,y+2,width-4,height-4)
			End Select
		Case WGV_StatePressed
		;-----------------   ----------------
		;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-   -=======
			If selWidth>0 Then
				WG_SetViewport(x+1,y+1,width-2,height-2)
				WG_SetColorF WGV_LightBorder,0,0
				xDrawRectSimple(x+selStart+WGV_TextBoxTextStartX,y+2,selWidth,height-4,1)
				WG_SetViewport()
			EndIf
		;=======-  -=======
			WG_SetColorF 0,1,0
			xDrawText(label$,x+WGV_TextBoxTextStartX,y+2,0,0,width-WGV_TextBoxWidthExtend)
		;=======-  -=======
			xGetFontProperty(WGV_Font)
			If cursor>=0 Then
				WG_SetColorF 0,1,0
				cursorx=x+WGV_TextBoxTextStartX-1+cursor
				cursory=y+(height-FI_FontProperty\Height) Shr 1
				xDrawLineSimple(cursorx,cursory,cursorx,cursory+FI_FontProperty\Height)
			EndIf
		Case WGV_StateLock
		;-----------------  ----------------
		;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			Select textAlign
				Case 0
					xDrawText(label$,x+WGV_TextBoxTextStartX,y+2,textAlign,0,width-WGV_TextBoxWidthExtend)
				Case 1
					WG_DrawText(label$,x+width Shr 1,y+2,textAlign,0,x+2,y+2,width-4,height-4)
				Case 2
					WG_DrawText(label$,x+width-WGV_TextBoxTextStartX,y+2,textAlign,0,x+2,y+2,width-4,height-4)
			End Select
	End Select
End Function

Function WG_DrawTextArea(x%,y%,width%,height%,label$,txtWidth%,state%,alpha#,scrollH%,crX%=-10,crY%=0,rBank%=0,rStart%=0,rEnd%=0,selRows%=0,selBank%=0)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),cursorx%,cursory%,i%,start%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StatePassive
		;-----------------  ----------------
		;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			WG_SetColorF 0,1,0
			If WG_SetViewport(x+WGV_TextBoxTextStartX,y+2,width-WGV_TextBoxWidthExtend-WGV_ScrollBarWidth,height-3)=1 Then
				WG_DrawTextRect label$,x-scrollH+WGV_TextBoxTextStartX,y+2,txtWidth,1000,4,0
				WG_SetViewport()
			EndIf
		Case WGV_StateActive
		;-----------------  ----------------
		;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			WG_SetColorF 0,1,0
			If WG_SetViewport(x+WGV_TextBoxTextStartX,y+2,width-WGV_TextBoxWidthExtend-WGV_ScrollBarWidth,height-3)=1 Then
				WG_DrawTextRect label$,x-scrollH+WGV_TextBoxTextStartX,y+2,txtWidth,1000,4,0
				WG_SetViewport()
			EndIf
		Case WGV_StatePressed
		;-----------------   ----------------
		;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;	----------===   ===----------
			If WG_SetViewport(x+2,y+2,width-WGV_ScrollBarWidth-4,height-3)=1 Then
			;	----------===   ===----------
				WG_SetColorF WGV_LightBorder,0,0
				For i=0 To selRows-1
					xDrawRectSimple(x+PeekInt(selBank,i*10+2)+WGV_TextBoxTextStartX,y+2+FI_FontProperty\Height*PeekShort(selBank,i*10),PeekInt(selBank,i*10+6),FI_FontProperty\Height,1)
				Next
			;	----------===  ===----------
				WG_SetColorF 0,1,0
				;WG_DrawTextRect label$,x-scrollH+WGV_TextBoxTextStartX,y+2,txtWidth,1000,4,0
				For i=rStart To rEnd
					start=PeekShort(rBank,i*4)
					xDrawText(Mid(label,start,PeekShort(rBank,i*4+2)-start+1),x-scrollH+WGV_TextBoxTextStartX,y+2+FI_FontProperty\Height*(i-rStart))
				Next
			;	----------===  ===----------
				If crX>-10 Then
					WG_SetColorF 0,1,0
					crX=crX+x+WGV_TextBoxTextStartX-1
					crY=crY+y
					xDrawLineSimple(crX,crY,crX,crY+FI_FontProperty\Height)
				EndIf
			;	----------===   ===----------
				WG_SetViewport()
			EndIf
		Case WGV_StateLock
		;-----------------  ----------------
		;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			If WG_SetViewport(x+WGV_TextBoxTextStartX,y+2,width-WGV_TextBoxWidthExtend-WGV_ScrollBarWidth,height-3)=1 Then
				WG_DrawTextRect label$,x-scrollH+WGV_TextBoxTextStartX,y+2,txtWidth,1000,4,0
				WG_SetViewport()
			EndIf
	End Select
End Function

Function WG_DrawListBox(x%,y%,width%,height%,label$,state%,alpha#)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255)
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StateLock
		;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		Default
		;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
	End Select
End Function

Function WG_DrawComboBox(x%,y%,width%,height%,label$,state%,alpha#,textAlign%)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),buttonSize%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StateActive,WGV_StatePressed
		;=======-  -=======
			WG_SetColorF(WGV_Border,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			buttonSize=height-2
			WG_DrawButton(x+width-height+1,y+1,buttonSize,buttonSize,"",WGV_IconScrollDown,1,buttonSize,buttonSize,0,state,alpha,0)
		;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect label$,x+4,y+2,width-6-buttonSize,height-4,textAlign,1
;		Case WGV_StatePressed
;		;=======-  -=======
;			WG_SetColorF(WGV_Border,0,0)
;			xDrawRectSimple(x,y,width,height,0)
;		;=======-  -=======
;			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
;			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
;			xSetCustomColor(color0,color1,color2,color3)
;			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
;		;=======-  -=======
;			buttonSize=height-2
;			WG_DrawButton(x+width-height+1,y+1,buttonSize,buttonSize,"",WGV_IconScrollDown,1,buttonSize,buttonSize,0,state,alpha,0)
;		;=======-  -=======
;			WG_SetColorF 0,1,0
;			WG_DrawTextRect label$,x+4,y+2,width-6-buttonSize,height-3
		Case WGV_StatePassive
		;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			buttonSize=height-2
			WG_DrawButton(x+width-height+1,y+1,buttonSize,buttonSize,"",WGV_IconScrollDown,1,buttonSize,buttonSize,0,state,alpha,0)
		;=======-  -=======
			WG_SetColorF 0,1,0
			WG_DrawTextRect label$,x+4,y+2,width-6-buttonSize,height-4,textAlign,1
		Case WGV_StateLock
		;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(x,y,width,height,0)
		;=======-  -=======
			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon)
			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LockFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			xSetCustomColor(color0,color1,color2,color3)
			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
		;=======-  -=======
			buttonSize=height-2
			WG_DrawButton(x+width-height+1,y+1,buttonSize,buttonSize,"",WGV_IconScrollDown,1,buttonSize,buttonSize,0,state,alpha,0)
		;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			WG_DrawTextRect label$,x+4,y+2,width-6-buttonSize,height-4,textAlign,1
	End Select
End Function

Function WG_DrawScrollBar(WG.TScrollBar,x%,y%,width%,height%,state%,textAlign%,alpha#)
	Local colorF%[3],colorS%[3],alphaInt%=Int(alpha*255)
	Local textColor%,x1%,x2%,y1%,y2%,color_1%,color_2%,color_3%,color_4%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
;=======-  -=======
	If WG\markBank<>0 Then
		Local shift%,i%,value$,coord%
		
		If state=WGV_StateLock Then
			WG_SetColorF(WGV_LockText,1,0)
		Else
			WG_SetColorF(0,1,0)
		EndIf
		
		Select WG\direction
			Case 0,3
				If WG\inverse=0 Then
					For i=0 To BankSize(WG\markBank)-1 Step 3
						shift=PeekShort(WG\markBank,i+1)
						If PeekByte(WG\markBank,i)=1 Then
							xDrawLineSimple(x+shift,y-7,x+shift,y+2)
						Else
							xDrawLineSimple(x+shift,y-3,x+shift,y+2)
						EndIf
					Next
					If WG\markTextBank<>0 Then
						coord=y-8
						If Int(WG\scale)=WG\scale Then
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekInt(WG\markTextBank,i+2),x+PeekShort(WG\markTextBank,i),coord,1,2)
							Next
						Else
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekFloat(WG\markTextBank,i+2),x+PeekShort(WG\markTextBank,i),coord,1,2)
							Next
						EndIf
					EndIf
				Else
					coord=y+height-1
					For i=0 To BankSize(WG\markBank)-1 Step 3
						shift=PeekShort(WG\markBank,i+1)
						If PeekByte(WG\markBank,i)=1 Then
							xDrawLineSimple(x+shift,coord+7,x+shift,coord-2)
						Else
							xDrawLineSimple(x+shift,coord+3,x+shift,coord-2)
						EndIf
					Next
					If WG\markTextBank<>0 Then
						coord=y+8+height-1
						If Int(WG\scale)=WG\scale Then
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekInt(WG\markTextBank,i+2),x+PeekShort(WG\markTextBank,i),coord,1,0)
							Next
						Else
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekFloat(WG\markTextBank,i+2),x+PeekShort(WG\markTextBank,i),coord,1,0)
							Next
						EndIf
					EndIf
				EndIf
			Case 1,2
				If WG\inverse=0 Then
					For i=0 To BankSize(WG\markBank)-1 Step 3
						shift=PeekShort(WG\markBank,i+1)
						If PeekByte(WG\markBank,i)=1 Then
							xDrawLineSimple(x-7,y+shift,x+2,y+shift)
						Else
							xDrawLineSimple(x-3,y+shift,x+2,y+shift)
						EndIf
					Next
					If WG\markTextBank<>0 Then
						coord=x-WGV_Space
						If Int(WG\scale)=WG\scale Then
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekInt(WG\markTextBank,i+2),coord,y+PeekShort(WG\markTextBank,i),2,1)
							Next
						Else
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekFloat(WG\markTextBank,i+2),coord,y+PeekShort(WG\markTextBank,i),2,1)
							Next
						EndIf
					EndIf
				Else
					coord=x+width-1
					For i=0 To BankSize(WG\markBank)-1 Step 3
						shift=PeekShort(WG\markBank,i+1)
						If PeekByte(WG\markBank,i)=1 Then
							xDrawLineSimple(coord+7,y+shift,coord-2,y+shift)
						Else
							xDrawLineSimple(coord+3,y+shift,coord-2,y+shift)
						EndIf
					Next
					If WG\markTextBank<>0 Then
						coord=x+WGV_Space+width
						If Int(WG\scale)=WG\scale Then
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekInt(WG\markTextBank,i+2),coord,y+PeekShort(WG\markTextBank,i),0,1)
							Next
						Else
							For i=0 To BankSize(WG\markTextBank)-1 Step 6
								xDrawText(PeekFloat(WG\markTextBank,i+2),coord,y+PeekShort(WG\markTextBank,i),0,1)
							Next
						EndIf
					EndIf
				EndIf
		End Select
	EndIf

;-----------------       ----------------
	Select state
		Case WGV_StatePassive
		;-----------------   ----------------
			textColor=0
			
		;-----------------     ----------------
			Select WG\barStyle
				Case 0
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					color_1=WGV_MidLightBorder
				Case 1
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_Border) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_Border) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					color_1=WGV_DarkFon
					color_2=WGV_LightFon
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_DarkFon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_DarkFon)
					color_3=WGV_LightBorder
					color_4=WGV_MidLightBorder
			End Select
		Case WGV_StateActive
		;-----------------   ----------------
			textColor=0
			
		;-----------------     ----------------
			Select WG\barStyle
				Case 0
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					color_1=WGV_Border
				Case 1
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_Border) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_Border) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					color_1=WGV_DarkFon
					color_2=WGV_LightFon
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_DarkFon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_DarkFon)
					color_3=WGV_MidLightBorder
					color_4=WGV_Border
			End Select
		Case WGV_StatePressed
		;-----------------   ----------------
			textColor=0
			
		;-----------------     ----------------
			Select WG\barStyle
				Case 0
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					color_1=WGV_Border
				Case 1
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_Border) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_Border) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder)
					color_1=WGV_DarkFon
					color_2=WGV_LightFon
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_DarkFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_DarkFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
					color_3=WGV_MidLightBorder
					color_4=WGV_Border
			End Select
		Case WGV_StateLock
		;-----------------   ----------------
			textColor=WGV_LockText
			
		;-----------------     ----------------
			Select WG\barStyle
				Case 0
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightFon)
					color_1=WGV_LightBorder
				Case 1
			;-----------------   ----------------
					colorF[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder) : colorF[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder)
					colorF[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_MidLightBorder) : colorF[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightBorder)
					color_1=WGV_Fon
					color_2=WGV_MidLightFon
			;-----------------   ----------------
					colorS[0]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : colorS[1]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					colorS[3]=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : colorS[2]=(alphaInt Shl 24) Or WG_GetColor(WGV_Fon)
					color_3=WGV_LightBorder
					color_4=WGV_MidLightBorder
			End Select
	End Select
	
	
	Select WG\direction
		Case 0,3
			Select WG\barStyle
				Case 0
			;-----------------  ----------------
					xSetCustomColor(colorF[3],colorF[0],colorF[1],colorF[2])
					xDrawRectSimple(x,y,width,height,1)
			;-----------------  ----------------
					;-----------------  ----------------
					xSetCustomColor(colorS[3],colorS[0],colorS[1],colorS[2])
					xDrawRectSimple(x+WG\sliderX+1,y+1,WG\sliderLen-2,height-2,1)
					;-----------------  ----------------
					WG_SetColorF(color_1,0,0)
					xDrawRectSimple(x+WG\sliderX,y,WG\sliderLen,height,0)
				Case 1
			;-----------------  ----------------
					xSetCustomColor(colorF[3],colorF[0],colorF[1],colorF[2])
					xDrawRectSimple(x+1,y+5,width-2,height-10,1)
					WG_SetColorF(color_1,0,0)
					xDrawLineSimple(x+2,y+4,x+width-3,y+4)
					xDrawLineSimple(x,y+6,x,y+height-7)
					xDrawPlot(x+1,y+5)
					xDrawPlot(x+1,y+height-6)
					xDrawPlot(x+width-2,y+5)
					WG_SetColorF(color_2,0,0)
					xDrawLineSimple(x+2,y+height-5,x+width-3,y+height-5)
					xDrawLineSimple(x+width-1,y+6,x+width-1,y+height-7)
					xDrawPlot(x+width-2,y+height-6)
			;-----------------  ----------------
					;-----------------  ----------------
					xSetCustomColor(colorS[3],colorS[0],colorS[1],colorS[2])
					xDrawRectSimple(x+WG\sliderX+1,y+4,WG\sliderLen-2,height-8,1)
					;-----------------  ----------------
					WG_SetColorF(color_3,0,0)
					x1=x+WG\sliderX
					x2=x+WG\sliderX+WG\sliderLen-1
					xDrawLineSimple(x1+2,y+3,x2-2,y+3)
					xDrawLineSimple(x1,y+5,x1,y+height-6)
					xDrawPlot(x1+1,y+4)
					xDrawPlot(x2-1,y+4)
					WG_SetColorF(color_4,0,0)
					xDrawLineSimple(x1+2,y+height-4,x2-2,y+height-4)
					xDrawLineSimple(x2,y+5,x2,y+height-6)
					xDrawPlot(x1+1,y+height-5)
					xDrawPlot(x2-1,y+height-5)
			End Select
		Case 1,2
			Select WG\barStyle
				Case 0
			;-----------------  ----------------
					xSetCustomColor(colorF[0],colorF[1],colorF[2],colorF[3])
					xDrawRectSimple(x,y,width,height,1)
			;-----------------  ----------------
					;-----------------  ----------------
					xSetCustomColor(colorS[0],colorS[1],colorS[2],colorS[3])
					xDrawRectSimple(x+1,y+WG\sliderX+1,width-2,WG\sliderLen-2,1)
					;-----------------  ----------------
					WG_SetColorF(color_1,0,0)
					xDrawRectSimple(x,y+WG\sliderX,width,WG\sliderLen,0)
				Case 1
			;-----------------  ----------------
					xSetCustomColor(colorF[0],colorF[1],colorF[2],colorF[3])
					xDrawRectSimple(x+5,y+1,width-10,height-2,1)
					WG_SetColorF(color_1,0,0)
					xDrawLineSimple(x+4,y+2,x+4,y+height-3)
					xDrawLineSimple(x+6,y,x+width-7,y)
					xDrawPlot(x+5,y+1)
					xDrawPlot(x+5,y+height-2)
					xDrawPlot(x+width-6,y+1)
					WG_SetColorF(color_2,0,0)
					xDrawLineSimple(x+width-5,y+2,x+width-5,y+height-3)
					xDrawLineSimple(x+6,y+height-1,x+width-7,y+height-1)
					xDrawPlot(x+width-6,y+height-2)
			;-----------------  ----------------
					;-----------------  ----------------
					xSetCustomColor(colorS[0],colorS[1],colorS[2],colorS[3])
					xDrawRectSimple(x+4,y+WG\sliderX+1,width-8,WG\sliderLen-2,1)
					;-----------------  ----------------
					WG_SetColorF(color_3,0,0)
					y1=y+WG\sliderX
					y2=y+WG\sliderX+WG\sliderLen-1
					xDrawLineSimple(x+3,y1+2,x+3,y2-2)
					xDrawLineSimple(x+5,y1,x+width-6,y1)
					xDrawPlot(x+4,y1+1)
					xDrawPlot(x+width-5,y1+1)
					WG_SetColorF(color_4,0,0)
					xDrawLineSimple(x+width-4,y1+2,x+width-4,y2-2)
					xDrawLineSimple(x+5,y2,x+width-6,y2)
					xDrawPlot(x+4,y2-1)
					xDrawPlot(x+width-5,y2-1)
			End Select
	End Select
	
	;-----------------   ----------------
	If WG\showValue=True Then
		If Int(WG\scale)=WG\scale Then
			value=Str(WG\value*Int(WG\scale))
		Else
			value=Str(Float(WG\value)*WG\scale)
		EndIf
		WG_SetColorF(textColor,1,0)
		Select textAlign
			Case 0	;	 
				xDrawText(value,x+(width Shr 1),y+(height Shr 1),1,1)
			Case 1	;	
				xDrawText(value,x+(width Shr 1),y-WGV_Space+1,1,2)
			Case 2	;	
				xDrawText(value,x+(width Shr 1),y+height+WGV_Space,1,0)
			Case 3	;	
				xDrawText(value,x-WGV_Space+1,y+(height Shr 1),2,1)
			Case 4	;	
				xDrawText(value,x+width+WGV_Space,y+(height Shr 1),0,1)
		End Select
	EndIf
End Function

Function WG_DrawFrame(x%,y%,width%,height%,label$,textAlign%,state%,alpha#)
	Local lCut%,rCut%,shiftY%,maxW%=width-(WGV_Space Shl 1)-WGV_Space
	
	If label<>"" Then
		Select textAlign
			Case 0
				lCut=WGV_Space
				rCut=lCut+WGV_Space+xStringWidthEx(label,maxW)
			Case 1
				lCut=(width-WGV_Space-xStringWidthEx(label,maxW)) Shr 1
				rCut=width-lCut
			Case 2
				rCut=width-WGV_Space
				lCut=rCut-WGV_Space-xStringWidthEx(label,maxW)
		End Select
		shiftY=y+xStringHeightEx(label) Shr 1
	Else
		lCut=rCut
	EndIf
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StateLock
			If lCut=rCut Then
				WG_SetColorF(WGV_MidLightFon,0,0)
				xDrawRectSimple(x+1,y+1,width-1,height-1,0)
				WG_SetColorF(WGV_DarkFon,0,0)
				xDrawRectSimple(x,y,width-1,height-1,0)
			Else
				WG_SetColorF(WGV_MidLightFon,0,0)
				xDrawText(label,x+lCut+WGV_SpaceMini+2,y+1,0,0,maxW)
				WG_SetColorF(WGV_LockText,1,0)
				xDrawText(label,x+lCut+WGV_SpaceMini+1,y,0,0,maxW)
				WG_SetColorF(WGV_MidLightFon,0,0)
				xDrawLineSimple(x+1,shiftY+1,x+lCut-1,shiftY+1)
				xDrawLineSimple(x+rCut,shiftY+1,x+width-1,shiftY+1)
				xDrawLineSimple(x+1,shiftY+1,x+1,y+height-1)
				xDrawLineSimple(x+width-1,shiftY+1,x+width-1,y+height-1)
				xDrawLineSimple(x+1,y+height-1,x+width-1,y+height-1)
				WG_SetColorF(WGV_DarkFon,0,0)
				xDrawLineSimple(x,shiftY,x+lCut-1,shiftY)
				xDrawLineSimple(x+rCut,shiftY,x+width-2,shiftY)
				xDrawLineSimple(x,shiftY,x,y+height-2)
				xDrawLineSimple(x+width-2,shiftY,x+width-2,y+height-2)
				xDrawLineSimple(x,y+height-2,x+width-2,y+height-2)
			EndIf
		Default
			If lCut=rCut Then
				WG_SetColorF(WGV_LightedBorder,0,0)
				xDrawRectSimple(x+1,y+1,width-1,height-1,0)
				WG_SetColorF(WGV_Border,0,0)
				xDrawRectSimple(x,y,width-1,height-1,0)
			Else
				WG_SetColorF(WGV_LightedBorder,0,0)
				xDrawText(label,x+lCut+WGV_SpaceMini+2,y+1,0,0,maxW)
				WG_SetColorF(0,1,0)
				xDrawText(label,x+lCut+WGV_SpaceMini+1,y,0,0,maxW)
				WG_SetColorF(WGV_LightedBorder,0,0)
				xDrawLineSimple(x+1,shiftY+1,x+lCut-1,shiftY+1)
				xDrawLineSimple(x+rCut,shiftY+1,x+width-1,shiftY+1)
				xDrawLineSimple(x+1,shiftY+1,x+1,y+height-1)
				xDrawLineSimple(x+width-1,shiftY+1,x+width-1,y+height-1)
				xDrawLineSimple(x+1,y+height-1,x+width-1,y+height-1)
				WG_SetColorF(WGV_Border,0,0)
				xDrawLineSimple(x,shiftY,x+lCut-1,shiftY)
				xDrawLineSimple(x+rCut,shiftY,x+width-2,shiftY)
				xDrawLineSimple(x,shiftY,x,y+height-2)
				xDrawLineSimple(x+width-2,shiftY,x+width-2,y+height-2)
				xDrawLineSimple(x,y+height-2,x+width-2,y+height-2)
			EndIf
	End Select
End Function

Function WG_DrawDivider(x%,y%,length%,vertical%,label$,textAlign%,state%,alpha#)
	Local lCut%,rCut%,shiftY%,maxW%=length-(WGV_Space Shl 1)-WGV_Space
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select vertical
		Case 1
			Select state
				Case WGV_StateLock
					WG_SetColorF(WGV_DarkFon,0,0)
					xDrawLineSimple(x,y,x,y+length-1)
					WG_SetColorF(WGV_MidLightFon,0,0)
					xDrawLineSimple(x+1,y,x+1,y+length-1)
				Default
					WG_SetColorF(WGV_Border,0,0)
					xDrawLineSimple(x,y,x,y+length-1)
					WG_SetColorF(WGV_LightedBorder,0,0)
					xDrawLineSimple(x+1,y,x+1,y+length-1)
			End Select
		Default
			If label<>"" Then
				Select textAlign
					Case 0
						lCut=WGV_Space
						rCut=lCut+WGV_Space+xStringWidthEx(label,maxW)
					Case 1
						lCut=(length-WGV_Space-xStringWidthEx(label,maxW)) Shr 1
						rCut=length-lCut
					Case 2
						rCut=length-WGV_Space
						lCut=rCut-WGV_Space-xStringWidthEx(label,maxW)
				End Select
				shiftY=y-xStringHeightEx(label) Shr 1
			Else
				lCut=rCut
			EndIf
			
			Select state
				Case WGV_StateLock
					If lCut=rCut Then
						WG_SetColorF(WGV_DarkFon,0,0)
						xDrawLineSimple(x,y,x+length-1,y)
						WG_SetColorF(WGV_MidLightFon,0,0)
						xDrawLineSimple(x,y+1,x+length-1,y+1)
					Else
						WG_SetColorF(WGV_MidLightFon,0,0)
						xDrawText(label,x+lCut+WGV_SpaceMini+2,shiftY+1,0,0,maxW)
						WG_SetColorF(WGV_LockText,1,0)
						xDrawText(label,x+lCut+WGV_SpaceMini+1,shiftY,0,0,maxW)
						WG_SetColorF(WGV_DarkFon,0,0)
						xDrawLineSimple(x,y,x+lCut-1,y)
						xDrawLineSimple(x+rCut,y,x+length-1,y)
						WG_SetColorF(WGV_MidLightFon,0,0)
						xDrawLineSimple(x,y+1,x+lCut-1,y+1)
						xDrawLineSimple(x+rCut,y+1,x+length-1,y+1)
					EndIf
				Default
					If lCut=rCut Then
						WG_SetColorF(WGV_Border,0,0)
						xDrawLineSimple(x,y,x+length-1,y)
						WG_SetColorF(WGV_LightedBorder,0,0)
						xDrawLineSimple(x,y+1,x+length-1,y+1)
					Else
						WG_SetColorF(WGV_LightedBorder,0,0)
						xDrawText(label,x+lCut+WGV_SpaceMini+2,shiftY+1,0,0,maxW)
						WG_SetColorF(0,1,0)
						xDrawText(label,x+lCut+WGV_SpaceMini+1,shiftY,0,0,maxW)
						WG_SetColorF(WGV_Border,0,0)
						xDrawLineSimple(x,y,x+lCut-1,y)
						xDrawLineSimple(x+rCut,y,x+length-1,y)
						WG_SetColorF(WGV_LightedBorder,0,0)
						xDrawLineSimple(x,y+1,x+lCut-1,y+1)
						xDrawLineSimple(x+rCut,y+1,x+length-1,y+1)
					EndIf
			End Select
	End Select
End Function

Function WG_DrawMenuButton(x%,y%,width%,height%,state%,label$,alpha#)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255)
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StatePassive
		;=======-  -=======
			WG_SetColorF 0,1,0
			xDrawText label$,x+(width Shr 1),y+(height Shr 1),1,1
		Case WGV_StateActive
		;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(x,y,width,height)
		;=======-  -=======
			WG_SetColorF 0,1,0
			xDrawText label$,x+(width Shr 1),y+(height Shr 1),1,1
		Case WGV_StatePressed,WGV_StateToggledActive,WGV_StateToggledPassive
		;=======-  -=======
			WG_SetColorF(WGV_MidLightBorder,0,0)
			xDrawRectSimple(x,y,width,height)
		;=======-  -=======
			WG_SetColorF 0,1,0
			xDrawText label$,x+(width Shr 1),y+(height Shr 1),1,1
		Case WGV_StateLock
		;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			xDrawText label$,x+(width Shr 1),y+(height Shr 1),1,1
	End Select
End Function

Function WG_DrawContextMenuButton(x%,y%,width%,height%,state%,label$,alpha#,icon,icontype%,iconWidth%,iconHeight%,iconFrame%,hotkey$,context%)
	Local color0%,color1%,color2%,color3%,alphaInt%=Int(alpha*255),widthX%,heightX%
	
;-----------------    ----------------
	xSetAlpha(alpha)
	
	Select state
		Case WGV_StatePassive
			widthX=WGV_IconWidth+WGV_ButtonContextMenuIndent Shl 1
			heightX=height Shr 1
		;=======-  -=======
			WG_SetColorF 0,1,0
			xDrawText label$,x+widthX,y+heightX,0,1
			If hotkey$<>"" Then
				xDrawText hotkey$,x+width-widthX,y+heightX,2,1
			EndIf
		;=======-  -=======
			Select icontype
				Case 1
					WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon)
				Case 2,3
					xSetColor(255,255,255)
					xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
			End Select
			If context Then WG_DrawIcon(x+width-WGV_IconWidth,y,WGV_IconWidth,height,WGV_IconArrowForward)
		Case WGV_StateActive
			widthX=WGV_IconWidth+WGV_ButtonContextMenuIndent Shl 1
			heightX=height Shr 1
		;=======-  -=======
			WG_SetColorF(WGV_LightBorder,0,0)
			xDrawRectSimple(x,y,width,height)
		;=======-  -=======
			WG_SetColorF 0,1,0
			xDrawText label$,x+widthX,y+heightX,0,1
			If hotkey$<>"" Then
				xDrawText hotkey$,x+width-widthX,y+heightX,2,1
			EndIf
		;=======-  -=======
			Select icontype
				Case 1
					WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon)
				Case 2,3
					xSetColor(255,255,255)
					xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
			End Select
			If context Then WG_DrawIcon(x+width-WGV_IconWidth,y,WGV_IconWidth,height,WGV_IconArrowForward)
		Case WGV_StatePressed,WGV_StateToggledActive,WGV_StateToggledPressed
			widthX=WGV_IconWidth+WGV_ButtonContextMenuIndent Shl 1
			heightX=height Shr 1
			If context<>0 Then
			;=======-  -=======
				WG_SetColorF(WGV_MidLightBorder,0,0)
				xDrawRectSimple(x,y,width,height)
			;=======-  -=======
				WG_SetColorF 0,1,0
				xDrawText label$,x+widthX,y+heightX,0,1
				If hotkey$<>"" Then
					xDrawText hotkey$,x+width-widthX,y+heightX,2,1
				EndIf
			;=======-  -=======
				Select icontype
					Case 1
						WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon)
					Case 2,3
						xSetColor(255,255,255)
						xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
				End Select
				WG_DrawIcon(x+width-WGV_IconWidth,y,WGV_IconWidth,height,WGV_IconArrowForward)
			Else
			;=======-  -=======
				WG_SetColorF(WGV_MidLightBorder,0,0)
				xDrawRectSimple(x,y,width,height)
			;=======-  -=======
				WG_SetColorF 0,1,0
				xDrawText label$,x+widthX,y+heightX,0,1
				If hotkey$<>"" Then
					xDrawText hotkey$,x+width-widthX,y+heightX,2,1
				EndIf
			;=======-  -=======
				Select icontype
					Case 1
						WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon)
					Case 2,3
						xSetColor(255,255,255)
						xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
				End Select
			EndIf
		Case WGV_StateToggledPassive
			widthX=WGV_IconWidth+WGV_ButtonContextMenuIndent Shl 1
			heightX=height Shr 1
			If context<>0 Then
			;=======-  -=======
				WG_SetColorF(WGV_MidLightBorder,0,0)
				xDrawRectSimple(x,y,width,height)
			;=======-  -=======
				WG_SetColorF 0,1,0
				xDrawText label$,x+widthX,y+heightX,0,1
				If hotkey$<>"" Then
					xDrawText hotkey$,x+width-widthX,y+heightX,2,1
				EndIf
			;=======-  -=======
				Select icontype
					Case 1
						WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon)
					Case 2,3
						xSetColor(255,255,255)
						xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
				End Select
				WG_DrawIcon(x+width-WGV_IconWidth,y,WGV_IconWidth,height,WGV_IconArrowForward)
			Else
			;=======-  -=======
				WG_SetColorF 0,1,0
				xDrawText label$,x+widthX,y+heightX,0,1
				If hotkey$<>"" Then
					xDrawText hotkey$,x+width-widthX,y+heightX,2,1
				EndIf
			;=======-  -=======
				Select icontype
					Case 0
						WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,WGV_IconPoint)
					Case 1
				;=======-  -=======
						WG_SetColorF(WGV_MidLightBorder,0,0)
						xDrawRectSimple(x+WGV_ButtonContextMenuIndent Shr 1,y,WGV_IconWidth+WGV_ButtonContextMenuIndent,height,0)
				;=======-  -=======
						color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
						color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
						xSetCustomColor(color0,color1,color2,color3)
						xDrawRectSimple(x+1+WGV_ButtonContextMenuIndent Shr 1,y+1,WGV_IconWidth+WGV_ButtonContextMenuIndent-2,height-2,1)
				;=======-  -=======
						WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon)
					Case 2,3
				;=======-  -=======
						WG_SetColorF(WGV_MidLightBorder,0,0)
						xDrawRectSimple(x+WGV_ButtonContextMenuIndent Shr 1,y,WGV_IconWidth+WGV_ButtonContextMenuIndent,height,0)
				;=======-  -=======
						color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
						color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
						xSetCustomColor(color0,color1,color2,color3)
						xDrawRectSimple(x+1+WGV_ButtonContextMenuIndent Shr 1,y+1,WGV_IconWidth+WGV_ButtonContextMenuIndent-2,height-2,1)
				;=======-  -=======
						xSetColor(255,255,255)
						xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
				End Select
			EndIf
;		Case WGV_StateToggledPassive
;				;=======-  -=======
;			WG_SetColorF(WGV_MidLightBorder,0,0)
;			xDrawRectSimple(x,y,width,height,0)
;				;=======-  -=======
;			color0=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color1=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon)
;			color3=(alphaInt Shl 24) Or WG_GetColor(WGV_LightedFon) : color2=(alphaInt Shl 24) Or WG_GetColor(WGV_LightFon)
;			xSetCustomColor(color0,color1,color2,color3)
;			xDrawRectSimple(x+1,y+1,width-2,height-2,1)
;				;=======-  -=======
;			xSetColor(255,255,255)
;			xDrawImageEx(icon,x+(WGV_ButtonWidthExtendI Shr 1),y+(WGV_ButtonHeightExtendI Shr 1))
		Case WGV_StateLock
			widthX=WGV_IconWidth+WGV_ButtonContextMenuIndent Shl 1
			heightX=height Shr 1
		;=======-  -=======
			WG_SetColorF WGV_LockText,1,0
			xDrawText label$,x+widthX,y+heightX,0,1
			If hotkey$<>"" Then
				xDrawText hotkey$,x+width-widthX,y+heightX,2,1
			EndIf
		;=======-  -=======
			Select icontype
				Case 1
					WG_DrawIcon(x+WGV_ButtonContextMenuIndent,y,WGV_IconWidth,height,icon,1)
				Case 2,3
					xSetColor(255,255,255)
					xDrawImageEx(icon,x+WGV_ButtonContextMenuIndent,y+WGV_ButtonHeightExtendI Shr 1,iconFrame)
			End Select
			If context Then WG_DrawIcon(x+width-WGV_IconWidth,y,WGV_IconWidth,height,WGV_IconArrowForward,1)
	End Select
End Function

Function WG_DrawDescription(x%,y%,eWidth%,eHeight%,lock%,txt$,direct%,align%,width%,height%)
	If lock=0 Then
		WG_SetColorF 0,1,0
	Else
		WG_SetColorF WGV_LockText,1,0
	EndIf
	
	If width>0 Then
		Select direct
			Case 0	;	
				Select align
					Case 0	;	 
						WG_DrawTextRect(txt,x-width-WGV_SpaceMini,y,width,height,4,align)
					Case 1	;	 
						WG_DrawTextRect(txt,x-width-WGV_SpaceMini,y-(height-eHeight)/2,width,height,4,align)
					Case 2	;	 
						WG_DrawTextRect(txt,x-width-WGV_SpaceMini,y+eHeight-height,width,height,4,align)
				End Select
			Case 2	;	
				Select align
					Case 0	;	 
						WG_DrawTextRect(txt,x+eWidth+WGV_SpaceMini+1,y,width,height,4,align)
					Case 1	;	 
						WG_DrawTextRect(txt,x+eWidth+WGV_SpaceMini+1,y-(height-eHeight)/2,width,height,4,align)
					Case 2	;	 
						WG_DrawTextRect(txt,x+eWidth+WGV_SpaceMini+1,y+eHeight-height,width,height,4,align)
				End Select
			Case 1	;	
				Select align
					Case 0	;	  
						WG_DrawTextRect(txt,x+WGV_SpaceMini,y-height-WGV_SpaceMini,width,height,4+align)
					Case 1	;	 
						WG_DrawTextRect(txt,x+(eWidth-width)/2,y-height-WGV_SpaceMini,width,height,4+align)
					Case 2	;	  
						WG_DrawTextRect(txt,x+eWidth-width,y-height-WGV_SpaceMini,width,height,4+align)
				End Select
			Case 3	;	
				Select align
					Case 0	;	  
						WG_DrawTextRect(txt,x+WGV_SpaceMini,y+eHeight+WGV_SpaceMini,width,height,4+align)
					Case 1	;	 
						WG_DrawTextRect(txt,x+(eWidth-width)/2,y+eHeight+WGV_SpaceMini,width,height,4+align)
					Case 2	;	  
						WG_DrawTextRect(txt,x+eWidth-width,y+eHeight+WGV_SpaceMini,width,height,4+align)
				End Select
		End Select
	Else
		Select direct
			Case 0	;	
				xDrawText(txt,x-WGV_SpaceMini,y+eHeight*(Float(align)/2.0),2,align)
			Case 2	;	
				xDrawText(txt,x+eWidth+WGV_SpaceMini+1,y+eHeight*(Float(align)/2.0),0,align)
			Case 1	;	
				xDrawText(txt,x+WGV_SpaceMini+(eWidth-WGV_Space)*(Float(align)/2.0),y-WGV_SpaceMini,align,2)
			Case 3	;	
				xDrawText(txt,x+WGV_SpaceMini+(eWidth-WGV_Space)*(Float(align)/2.0),y+eHeight+WGV_SpaceMini,align,0)
		End Select
	EndIf
End Function

Function WG_DrawHelp()
		;=======-  -=======
	WG_SetColorF(WGV_MidLightBorder)
	xDrawRect(WGV_HelpX,WGV_HelpY,WGV_HelpWidth,WGV_HelpHeight,0)
		;=======-  -=======
	WG_SetColorF(WGV_LightFon)
	xDrawRect(WGV_HelpX+1,WGV_HelpY+1,WGV_HelpWidth-2,WGV_HelpHeight-2,1)
		;=======-  -=======
	WG_SetColorF(0,1,0)
	WG_DrawTextRect(WGV_HelpText,WGV_HelpX+WGV_HelpIndent,WGV_HelpY+WGV_HelpIndent,WGV_HelpWidth-WGV_HelpIndent,1000,4)
End Function

Function WG_DrawIcon(x%,y%,width%,height%,icon%,lock=0)
	Local halfsize%,fourthsize%,eighthsize%,minsize%,i%
	
	If width>height Then
		minsize=height
		x=x+(width-minsize) Shr 1
	Else
		minsize=width
		y=y+(height-minsize) Shr 1
	EndIf
	
	Select icon
		Case WGV_IconTick	;	
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
	;-----------------     ----------------
			If lock Then
		;-----------------    ----------------
				WG_SetColorF WGV_LightText,1,0
		;-----------------     ----------------
				WG_GetColor WGV_LockText,1,0,1
			Else
		;-----------------    ----------------
				WG_SetColorF 0,1,0
		;-----------------     ----------------
				WG_GetColor WGV_LightText,1,0,1
			EndIf
			
			xDrawLineSimple(x+eighthsize,y+halfsize,x+eighthsize+fourthsize,y+fourthsize+halfsize)
			xDrawLineSimple(x+eighthsize+fourthsize,y+halfsize+fourthsize,x+minsize-eighthsize,y+fourthsize)
	;-----------------    ----------------
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+eighthsize,y+halfsize+1,x+eighthsize+fourthsize,y+fourthsize+halfsize+1)
			xDrawLineSimple(x+eighthsize+fourthsize,y+halfsize+fourthsize+1,x+minsize-eighthsize,y+fourthsize+1)
		Case WGV_IconPoint	;	
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			
	;-----------------     ----------------
			If lock Then
				WG_SetColorF WGV_LockText,1,0
			Else
				WG_SetColorF 0,1,0
			EndIf
			
			xDrawOval(x+fourthsize,y+fourthsize,halfsize,halfsize)
		Case WGV_IconFurl	;	
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
	;-----------------     ----------------
			If lock Then
				WG_SetColorF WGV_LightBorder,0,0
				WG_GetColor WGV_LightFon,0,0,1
			Else
				WG_SetColorF WGV_Border,0,0
				WG_GetColor WGV_LightedFon,0,0,1
			EndIf
			xDrawLineSimple(x+eighthsize+1,y+minsize-fourthsize-2,x+halfsize+1,y+minsize-fourthsize-2)
			xDrawLineSimple(x+halfsize+1,y+minsize-fourthsize-1,x+halfsize+1,y+minsize-eighthsize-2)
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+eighthsize,y+minsize-eighthsize-1,x+halfsize+1,y+minsize-eighthsize-1)
			xDrawLineSimple(x+eighthsize,y+minsize-fourthsize-2,x+eighthsize,y+minsize-eighthsize-2)
		Case WGV_IconClose	;	
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
			If lock Then
				WG_SetColorF WGV_LockText,1,0
				WG_GetColor WGV_LightText,1,0,1
			Else
				WG_SetColorF WGV_LightText,1,0
				WG_GetColor 0,1,0,1
			EndIf
			xDrawLineSimple(x+fourthsize,y+fourthsize+1,x+halfsize+fourthsize-1,y+halfsize+fourthsize)
			xDrawLineSimple(x+halfsize+fourthsize,y+fourthsize+1,x+fourthsize+1,y+halfsize+fourthsize)
			xDrawLineSimple(x+fourthsize+1,y+fourthsize,x+halfsize+fourthsize,y+halfsize+fourthsize-1)
			xDrawLineSimple(x+halfsize+fourthsize-1,y+fourthsize,x+fourthsize,y+halfsize+fourthsize-1)
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+fourthsize,y+fourthsize,x+halfsize+fourthsize,y+halfsize+fourthsize)
			xDrawLineSimple(x+halfsize+fourthsize,y+fourthsize,x+fourthsize,y+halfsize+fourthsize)
		Case WGV_IconArrowForward	;	 
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
	;-----------------     ----------------
			If lock Then
				WG_SetColorF WGV_LockText,1,0
			Else
				WG_SetColorF 0,1,0
			EndIf
			i=0
			While i<=fourthsize
				xDrawLineSimple(x+halfsize-eighthsize+i,y+fourthsize+i,x+halfsize-eighthsize+i,y+fourthsize+halfsize-i)
				i=i+1
			Wend
		Case WGV_IconScrollUp
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
			If lock Then
				WG_SetColorF WGV_LockText,1,0
				WG_GetColor WGV_LightText,1,0,1
			Else
				WG_SetColorF WGV_LightText,1,0
				WG_GetColor 0,1,0,1
			EndIf
			xDrawLineSimple(x+fourthsize-1,y+halfsize+eighthsize-2,x+halfsize-1,y+fourthsize+eighthsize-2)
			xDrawLineSimple(x+halfsize+fourthsize-1,y+halfsize+eighthsize-2,x+halfsize-1,y+fourthsize+eighthsize-2)
			xDrawLineSimple(x+fourthsize,y+halfsize+eighthsize-1,x+halfsize-1,y+fourthsize+eighthsize)
			xDrawLineSimple(x+halfsize+fourthsize-2,y+halfsize+eighthsize-1,x+halfsize-1,y+fourthsize+eighthsize)
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+fourthsize,y+halfsize+eighthsize-2,x+halfsize-1,y+fourthsize+eighthsize-1)
			xDrawLineSimple(x+halfsize+fourthsize-2,y+halfsize+eighthsize-2,x+halfsize-1,y+fourthsize+eighthsize-1)
		Case WGV_IconScrollDown
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
			If lock Then
				WG_SetColorF WGV_LockText,1,0
				WG_GetColor WGV_LightText,1,0,1
			Else
				WG_SetColorF WGV_LightText,1,0
				WG_GetColor 0,1,0,1
			EndIf
			xDrawLineSimple(x+fourthsize,y+fourthsize+eighthsize,x+halfsize-1,y+halfsize+eighthsize-1)
			xDrawLineSimple(x+halfsize+fourthsize-2,y+fourthsize+eighthsize,x+halfsize-1,y+halfsize+eighthsize-1)
			xDrawLineSimple(x+fourthsize-1,y+fourthsize+eighthsize+1,x+halfsize-1,y+halfsize+eighthsize+1)
			xDrawLineSimple(x+halfsize+fourthsize-1,y+fourthsize+eighthsize+1,x+halfsize-1,y+halfsize+eighthsize+1)
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+fourthsize,y+fourthsize+eighthsize+1,x+halfsize-1,y+halfsize+eighthsize)
			xDrawLineSimple(x+halfsize+fourthsize-2,y+fourthsize+eighthsize+1,x+halfsize-1,y+halfsize+eighthsize)
		Case WGV_IconScrollLeft
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
			If lock Then
				WG_SetColorF WGV_LockText,1,0
				WG_GetColor WGV_LightText,1,0,1
			Else
				WG_SetColorF WGV_LightText,1,0
				WG_GetColor 0,1,0,1
			EndIf
			xDrawLineSimple(x+halfsize+eighthsize-2,y+fourthsize-1,x+fourthsize+eighthsize-2,y+halfsize-1)
			xDrawLineSimple(x+halfsize+eighthsize-2,y+halfsize+fourthsize-1,x+fourthsize+eighthsize-2,y+halfsize-1)
			xDrawLineSimple(x+halfsize+eighthsize-1,y+fourthsize,x+fourthsize+eighthsize,y+halfsize-1)
			xDrawLineSimple(x+halfsize+eighthsize-1,y+halfsize+fourthsize-2,x+fourthsize+eighthsize,y+halfsize-1)
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+halfsize+eighthsize-2,y+fourthsize,x+fourthsize+eighthsize-1,y+halfsize-1)
			xDrawLineSimple(x+halfsize+eighthsize-2,y+halfsize+fourthsize-2,x+fourthsize+eighthsize-1,y+halfsize-1)
		Case WGV_IconScrollRight
			halfsize=minsize Shr 1
			fourthsize=minsize Shr 2
			eighthsize=minsize Shr 3
			
			If lock Then
				WG_SetColorF WGV_LockText,1,0
				WG_GetColor WGV_LightText,1,0,1
			Else
				WG_SetColorF WGV_LightText,1,0
				WG_GetColor 0,1,0,1
			EndIf
			xDrawLineSimple(x+fourthsize+eighthsize,y+fourthsize,x+halfsize+eighthsize-1,y+halfsize-1)
			xDrawLineSimple(x+fourthsize+eighthsize,y+halfsize+fourthsize-2,x+halfsize+eighthsize-1,y+halfsize-1)
			xDrawLineSimple(x+fourthsize+eighthsize+1,y+fourthsize-1,x+halfsize+eighthsize+1,y+halfsize-1)
			xDrawLineSimple(x+fourthsize+eighthsize+1,y+halfsize+fourthsize-1,x+halfsize+eighthsize+1,y+halfsize-1)
			xSetColor WGV_TmpR,WGV_TmpG,WGV_TmpB
			xDrawLineSimple(x+fourthsize+eighthsize+1,y+fourthsize,x+halfsize+eighthsize,y+halfsize-1)
			xDrawLineSimple(x+fourthsize+eighthsize+1,y+halfsize+fourthsize-2,x+halfsize+eighthsize,y+halfsize-1)
	End Select
End Function

Function WG_SetColorScheme%(cScheme%)
	Select cScheme
		Case 1
			WGV_R=250
			WGV_G=250
			WGV_B=250
			WGV_RatioR=1.25
			WGV_RatioG=1.2
			WGV_RatioB=.85
			WGV_TextColorR=30
			WGV_TextColorG=45
			WGV_TextColorB=75
			WGV_TextRatioR=1.25
			WGV_TextRatioG=1.2
			WGV_TextRatioB=.85
			Return 1
		Case 2
		;#  
			WGV_R = 204
			WGV_G = 146
			WGV_B = 64
		;#    
			WGV_RatioR = 1.25
			WGV_RatioG = 1.2
			WGV_RatioB = 0.85
		;#  
			WGV_TextColorR = 221
			WGV_TextColorG = 210
			WGV_TextColorB = 75
		;#    
			WGV_TextRatioR = 1.29
			WGV_TextRatioG = 1.65
			WGV_TextRatioB = 0.1
			Return 1
		Case 3
		;#  
			WGV_R = 152
			WGV_G = 91
			WGV_B = 246
		;#    
			WGV_RatioR = 1.51772
			WGV_RatioG = 1.69933
			WGV_RatioB = 1.80305
		;#  
			WGV_TextColorR = 121
			WGV_TextColorG = 190
			WGV_TextColorB = 34
		;#    
			WGV_TextRatioR = 0.29
			WGV_TextRatioG = 1.96474
			WGV_TextRatioB = 1.30336
			Return 1
		Default
			Return 0
	End Select
End Function

Function WG_SetColorF(ColorDif%,textcolor%=0,invers=0)
	Local ColorR%,ColorG%,ColorB%
	
	Select textcolor
		Case 0
			ColorR=WGV_R-ColorDif*WGV_RatioR
			ColorG=WGV_G-ColorDif*WGV_RatioG
			ColorB=WGV_B-ColorDif*WGV_RatioB
		Case 1
			ColorR=WGV_TextColorR+ColorDif*WGV_TextRatioR
			ColorG=WGV_TextColorG+ColorDif*WGV_TextRatioG
			ColorB=WGV_TextColorB+ColorDif*WGV_TextRatioB
	End Select
	
	If invers=0
		If ColorR>255 Then ColorR=510-ColorR ElseIf ColorR<0 Then ColorR=-ColorR
		If ColorG>255 Then ColorG=510-ColorG ElseIf ColorG<0 Then ColorG=-ColorG
		If ColorB>255 Then ColorB=510-ColorB ElseIf ColorB<0 Then ColorB=-ColorB
	Else
		ColorR=ColorR And %11111111
		ColorG=ColorG And %11111111
		ColorB=ColorB And %11111111
	EndIf
	
;======-   -=======
	xSetColor ColorR,ColorG,ColorB
End Function

Function WG_GetColor%(ColorDif%,textcolor%=0,invers%=0,noReturn%=0)
	Local ColorR%,ColorG%,ColorB%
	
	Select textcolor
		Case 0
			ColorR=WGV_R-ColorDif*WGV_RatioR
			ColorG=WGV_G-ColorDif*WGV_RatioG
			ColorB=WGV_B-ColorDif*WGV_RatioB
		Case 1
			ColorR=WGV_TextColorR+ColorDif*WGV_TextRatioR
			ColorG=WGV_TextColorG+ColorDif*WGV_TextRatioG
			ColorB=WGV_TextColorB+ColorDif*WGV_TextRatioB
	End Select
	
	If invers=0
		If ColorR>255 Then ColorR=510-ColorR ElseIf ColorR<0 Then ColorR=-ColorR
		If ColorG>255 Then ColorG=510-ColorG ElseIf ColorG<0 Then ColorG=-ColorG
		If ColorB>255 Then ColorB=510-ColorB ElseIf ColorB<0 Then ColorB=-ColorB
	Else
		ColorR=ColorR And %11111111
		ColorG=ColorG And %11111111
		ColorB=ColorB And %11111111
	EndIf
	
	WGV_TmpR=ColorR
	WGV_TmpG=ColorG
	WGV_TmpB=ColorB
	
	If noReturn=0 Then Return (ColorR Shl 16) Or (ColorG Shl 8) Or ColorB
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D