;====================================================================
; Project:		GUIw512 Sample ElementAnimation
; Version:		1.08.0
; Author:		wolfhound512
; Email:		support@siberiansun.ru
; Copyright:	wolfhound512
; Description:	   
;				   
;                   
;====================================================================

Include "..\X3D_include\Xors3D.bb"

xGraphics3D 800,600,32,0
xSetBuffer xBackBuffer()

;	----------===  GUI ===----------
Include "..\X3D_include\GUIw512.bb"
;	----------===    GUI ===----------
Include "..\X3D_include\GUIw512_Style_Test.bb"

;	----------===  GUI ===----------
GUIw512_Init(1)

xSetFont xLoadFont ("Tahoma",16)

;	----------===  GUI ===----------
Local window%,button%

;	----------===   ===----------
window=WG_CreateWindow(350,200,300,200,"")

;	----------===   ===----------
button=WG_CreateButton(window,150,100,0,0,"",xLoadAnimTexture("..\media\icon_aero_color.png",11,32,32,0,55),2,6)

;	----------===    ===----------

; WG_SetElementAnimation% (Element%, WGA.TAnim)
;		:
; Element% -    
; WGA.TAnim -    
;		:
;       . 
;       : WGAnim.TAnim.
;         , 
;        . 
;		 : 
; WGV_AnimStop -  
; WGV_AnimLoopForward -    
; WGV_AnimLoopBack -    
; WGV_AnimOneShotForward -    
; WGV_AnimOneShotBack -    
; WGV_AnimPingPong - - ,   -  
; WGV_AnimPingPongBack - - ,   - 
;		   :
; WGAnim\frFirst[_] -     
; WGAnim\frLast[_] -     
; WGAnim\frRate[_] -   ()      
; WGAnim\animType[_] -    

WGAnim\frFirst[WGV_StatePassive]=18
WGAnim\frLast[WGV_StatePassive]=53
WGAnim\frRate[WGV_StatePassive]=70
WGAnim\animType[WGV_StatePassive]=WGV_AnimLoopForward

WGAnim\frFirst[WGV_StateActive]=0
WGAnim\frLast[WGV_StateActive]=17
WGAnim\frRate[WGV_StateActive]=30
WGAnim\animType[WGV_StateActive]=WGV_AnimLoopForward

WGAnim\frFirst[WGV_StatePressed]=0
WGAnim\frLast[WGV_StatePressed]=17
WGAnim\frRate[WGV_StatePressed]=30
WGAnim\animType[WGV_StatePressed]=WGV_AnimPingPongBack

WGAnim\frFirst[WGV_StateLock]=54
WGAnim\frLast[WGV_StateLock]=54
WGAnim\frRate[WGV_StateLock]=200
WGAnim\animType[WGV_StateLock]=0

;	----------===     ===----------
WG_SetElementAnimation(button,WGAnim)

;	----------===  3  ===----------
CreateWorld()

;	----------===   ===----------
While xKeyHit(1)=0
	
;	----------=== xRenderWorld ===----------
	xRenderWorld
	
;	----------=== UpDate GUI ===----------
	xStartDraw()
	
	GUIw512_UpDate()
	
	xEndDraw()
	
;	----------===  FPS ===----------
	xColor 100,110,120
	xText xGraphicsWidth() Shr 1,5,WGV_FPS,1
	
	xFlip
Wend

;	----------===  GUI   ===----------
GUIw512_UnLoad()

End

Function CreateWorld()
	Local light%,cam%,cub%,tex%
	
	light=xCreateLight()
	xRotateEntity light,45,-60,0
	cam=xCreateCamera()
	xCameraClsColor cam,10,20,30
	xCameraZoom cam,.3
	cub=xCreateCube()
	xRotateEntity cub,-10,-20,-10
	tex=xLoadTexture("..\media\LogoTex.png")
	xEntityTexture cub,tex
	xPositionEntity cub,-3,-1.7,6
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D